=== modified file '.bzrignore'
--- .bzrignore	2010-06-15 13:37:26 +0000
+++ .bzrignore	2010-06-15 23:59:32 +0000
@@ -7,7 +7,6 @@
 *.orig
 *.rej
 *.reject
-*.reject
 *.rpm
 *replication.pb.*
 *stamp-h
@@ -49,7 +48,6 @@
 config/bzr_revinfo
 config/pandora-plugin.list
 config/pandora_vc_revinfo
-config/pandora_vc_revinfo
 config/plugin-list.ac
 config/plugin-list.am
 config/plugin.ac
@@ -92,7 +90,6 @@
 drizzled/message/schema.pb.h
 drizzled/message/schema_reader
 drizzled/message/schema_writer
-drizzled/message/schema_writer
 drizzled/message/table.pb.cc
 drizzled/message/table.pb.h
 drizzled/message/table.pb.h
@@ -302,6 +299,7 @@
 unittests/atomics_test
 unittests/calendar_test
 unittests/unittests
+unittests/uwagi.txt
 virtual_column_info.gcno
 xid.gcno
 ylwrap

=== modified file 'drizzled/temporal.cc'
--- drizzled/temporal.cc	2010-04-23 01:02:40 +0000
+++ drizzled/temporal.cc	2010-06-04 15:32:25 +0000
@@ -40,9 +40,6 @@
 #include "drizzled/decimal.h"
 #include "drizzled/calendar.h"
 #include "drizzled/temporal.h"
-#ifdef NOTYETIMPLEMENTED
-#include "drizzled/temporal_interval.h"
-#endif
 #include "drizzled/temporal_format.h"
 #include "drizzled/time_functions.h"
 #include "time.h"
@@ -796,199 +793,7 @@
 
   return *this;
 }
-#ifdef NOTYETIMPLEMENTED
-Date& Date::operator+=(const TemporalIntervalYear &rhs)
-{
-  /* Simple one...add the years and adjust for any leaps */
-  int64_t new_years= _years;
-  new_years+= rhs._years;
-  if (new_years > DRIZZLE_MAX_YEARS_SQL)
-  {
-    /* 
-     * Set everything to zero. We got an overflow.
-     * @TODO Exceptions would be great here...
-     */
-    _reset();
-    _overflow= true;
-    return *this;
-  }
-  _years= (uint32_t) new_years;
-  if (_months == 2 && _days == 29 && days_in_gregorian_year_month(_years, _months) != 366)
-    _days= 28;
-  return *this;
-} 
-
-Date& Date::operator-=(const TemporalIntervalYear &rhs)
-{
-  /* Simple one...subtract the years and adjust for any leaps */
-  int64_t new_years= _years;
-  new_years-= rhs._years;
-  if (new_years < 0)
-  {
-    /* 
-     * Set everything to zero. We got an overflow.
-     * @TODO Exceptions would be great here...
-     */
-    _reset();
-    _overflow= true;
-    return *this;
-  }
-  _years= (uint32_t) new_years;
-  if (_months == 2 && _days == 29 && days_in_gregorian_year_month(_years, _months) != 366)
-    _days= 28;
-  return *this;
-} 
-
-Date& Date::operator+=(const TemporalIntervalDayOrWeek &rhs)
-{
-  /* Simple one...add the days */
-  int64_t julian_day= julian_day_number_from_gregorian_date(_years, _months, _days) + rhs._days;
-  gregorian_date_from_julian_day_number(julian_day, &_years, &_months, &_days);
-  return *this;
-} 
-
-Date& Date::operator-=(const TemporalIntervalDayOrWeek &rhs)
-{
-  /* Simple one...subtract the days */
-  int64_t julian_day= julian_day_number_from_gregorian_date(_years, _months, _days) - rhs._days;
-  gregorian_date_from_julian_day_number(julian_day, &_years, &_months, &_days);
-  return *this;
-} 
-
-Date& Date::operator+=(const TemporalIntervalYearMonth &rhs)
-{
-  /* Simple one...add the months in the period adjust */
-  int64_t period= (_years * 12) + (rhs._years * 12) + (_months - 1) + rhs._months;
-  int64_t new_years= (period / 12);
-  if (new_years > DRIZZLE_MAX_YEARS_SQL)
-  {
-    /* 
-     * Set everything to zero. We got an overflow.
-     * @TODO Exceptions would be great here...
-     */
-    _reset();
-    _overflow= true;
-    return *this;
-  }
-  _years= (uint32_t) new_years;
-  _months= (uint32_t) (period % 12) + 1;
-  
-  /* Adjust day if the new month doesn't have enough days */
-  uint32_t days_in_new_month= days_in_gregorian_year_month(_years, _months);
-  if (_days > days_in_new_month)
-    _days= days_in_new_month;
-  return *this;
-} 
-
-Date& Date::operator-=(const TemporalIntervalYearMonth &rhs)
-{
-  /* Simple one...subtract the months in the period and adjust */
-  int64_t period= (_years * 12) - (rhs._years * 12) + (_months - 1) - rhs._months;
-  int64_t new_years= (period / 12);
-  if (new_years < 0)
-  {
-    /* 
-     * Set everything to zero. We got an overflow.
-     * @TODO Exceptions would be great here...
-     */
-    _reset();
-    _overflow= true;
-    return *this;
-  }
-  _years= (uint32_t) (period / 12);
-  _months= (uint32_t) (period % 12) + 1;
-  
-  /* Adjust day if the new month doesn't have enough days */
-  uint32_t days_in_new_month= days_in_gregorian_year_month(_years, _months);
-  if (_days > days_in_new_month)
-    _days= days_in_new_month;
-  return *this;
-} 
-
-Date& Date::operator+=(const TemporalIntervalDayOrLess &rhs)
-{
-  /* 
-   * Convert the temporal and the interval into a number of 
-   * microseconds, then add them together and convert the
-   * resulting microseconds back into a broken-down temporal
-   * component.
-   */
-  int64_t new_seconds;
-  int64_t new_microseconds;
-  int64_t extra_sec;
-  int64_t new_days;
-  new_microseconds= _useconds + rhs._useconds;
-  extra_sec= new_microseconds / INT64_C(1000000);
-  new_microseconds= new_microseconds % INT64_C(1000000);
-
-  new_seconds= ((_days - 1) * 3600 * 24) + (_hours * 3600) + (_minutes * 60) + _seconds;
-  new_seconds+= (rhs._days * 3600 * 24) + (rhs._hours * 3600) + (rhs._minutes * 60) + rhs._seconds;
-  new_seconds+= extra_sec;
-
-  if (new_microseconds < 0)
-  {
-    new_microseconds+= INT64_C(1000000);
-    new_seconds--;
-  }
-  
-  new_days= new_seconds / (3600 * 24L);
-  new_seconds-= new_days * 3600 * 24L;
-  if (new_seconds < 0)
-  {
-    new_days--;
-    new_seconds+= 3600 * 24L;
-  }
-  _useconds= (uint32_t) new_microseconds;
-  _seconds= (uint32_t) (new_seconds % 60);
-  _minutes= (uint32_t) ((new_seconds / 60) % 60);
-  _hours= (uint32_t) (new_seconds / 3600);
-  int64_t julian_day= julian_day_number_from_gregorian_date(_years, _months, 1) + new_days;
-  gregorian_date_from_julian_day_number(julian_day, &_years, &_months, &_days);
-  return *this;
-}
-
-Date& Date::operator-=(const TemporalIntervalDayOrLess &rhs)
-{
-  /* 
-   * Convert the temporal and the interval into a number of 
-   * microseconds, then subtract them from each other and convert 
-   * the resulting microseconds back into a broken-down temporal
-   * component.
-   */
-  int64_t new_seconds;
-  int64_t new_microseconds;
-  int64_t extra_sec;
-  int64_t new_days;
-  new_microseconds= _useconds - rhs._useconds;
-  extra_sec= new_microseconds / INT64_C(1000000);
-  new_microseconds= new_microseconds % INT64_C(1000000);
-
-  new_seconds= ((_days - 1) * 3600 * 24) + (_hours * 3600) + (_minutes * 60) + _seconds;
-  new_seconds-= (rhs._days * 3600 * 24) + (rhs._hours * 3600) + (rhs._minutes * 60) + rhs._seconds;
-  new_seconds+= extra_sec;
-
-  if (new_microseconds < 0)
-  {
-    new_microseconds+= INT64_C(1000000);
-    new_seconds--;
-  }
-  
-  new_days= new_seconds / (3600 * 24L);
-  new_seconds-= new_days * 3600 * 24L;
-  if (new_seconds < 0)
-  {
-    new_days--;
-    new_seconds+= 3600 * 24L;
-  }
-  _useconds= (uint32_t) new_microseconds;
-  _seconds= (uint32_t) (new_seconds % 60);
-  _minutes= (uint32_t) ((new_seconds / 60) % 60);
-  _hours= (uint32_t) (new_seconds / 3600);
-  int64_t julian_day= julian_day_number_from_gregorian_date(_years, _months, 1) + new_days;
-  gregorian_date_from_julian_day_number(julian_day, &_years, &_months, &_days);
-  return *this;
-}
-#endif /* NOTYETIMPLEMENTED */
+
 /*
  * Comparison operators between a Date and a Timestamp
  */
@@ -1020,11 +825,11 @@
 }
 bool Date::operator>(const Timestamp& rhs)
 {
-  return ! (*this < rhs);
+  return ! (*this <= rhs);
 }
 bool Date::operator>=(const Timestamp& rhs)
 {
-  return ! (*this <= rhs);
+  return ! (*this < rhs);
 }
 /*
  * Comparison operators between a Timestamp and a Date
@@ -1057,11 +862,11 @@
 }
 bool Timestamp::operator>(const Date& rhs)
 {
-  return ! (*this < rhs);
+  return ! (*this <= rhs);
 }
 bool Timestamp::operator>=(const Date& rhs)
 {
-  return ! (*this <= rhs);
+  return ! (*this < rhs);
 }
 /*
  * Comparison operators between a Timestamp and a DateTime
@@ -1110,11 +915,11 @@
 }
 bool Timestamp::operator>(const DateTime& rhs)
 {
-  return ! (*this < rhs);
+  return ! (*this <= rhs);
 }
 bool Timestamp::operator>=(const DateTime& rhs)
 {
-  return ! (*this <= rhs);
+  return ! (*this < rhs);
 }
 /*
  * Comparison operators between two Timestamps
@@ -1137,11 +942,11 @@
 }
 bool Timestamp::operator>(const Timestamp& rhs)
 {
-  return ! (*this < rhs);
+  return ! (*this <= rhs);
 }
 bool Timestamp::operator>=(const Timestamp& rhs)
 {
-  return ! (*this <= rhs);
+  return ! (*this < rhs);
 }
 
 /**
@@ -1342,9 +1147,9 @@
 bool Time::from_int32_t(const int32_t from)
 {
   uint32_t copy_from= (uint32_t) from;
-  _hours= copy_from % INT32_C(10000);
-  _minutes= copy_from % INT32_C(100);
-  _seconds= copy_from & 3; /* Masks off all but last 2 digits */
+  _hours= copy_from / INT32_C(10000);
+  _minutes= (copy_from % INT32_C(10000)) / INT32_C(100);
+  _seconds= copy_from % INT32_C(100); /* Masks off all but last 2 digits */
   return is_valid();
 }
 
@@ -1383,7 +1188,7 @@
     else if (copy_from <  DRIZZLE_YY_PART_YEAR * 10000000000LL + 101000000LL)
       return false;
     else if (copy_from <= 991231235959LL)
-      copy_from= copy_from + 19000000000000LL;		/* YYMMDDHHMMSS, 1970-1999 */
+      copy_from= copy_from + 19000000000000LL;    /* YYMMDDHHMMSS, 1970-1999 */
   }
 
   part1= (int64_t) (copy_from / 1000000LL);

=== modified file 'drizzled/temporal.h'
--- drizzled/temporal.h	2009-12-14 20:19:41 +0000
+++ drizzled/temporal.h	2010-06-04 15:32:25 +0000
@@ -285,22 +285,6 @@
 
 
   /**
-   * Operator overload for adding/subtracting a TemporalInterval
-   * instance to this temporal.
-   *
-   * @param TemporalInterval instance to add/subtract to/from
-   */
-  Date& operator+=(const TemporalIntervalYear &rhs);
-  Date& operator+=(const TemporalIntervalDayOrLess &rhs);
-  Date& operator+=(const TemporalIntervalDayOrWeek &rhs);
-  Date& operator+=(const TemporalIntervalYearMonth &rhs);
-  Date& operator-=(const TemporalIntervalYear &rhs);
-  Date& operator-=(const TemporalIntervalDayOrLess &rhs);
-  Date& operator-=(const TemporalIntervalDayOrWeek &rhs);
-  Date& operator-=(const TemporalIntervalYearMonth &rhs);
-
-
-  /**
    * Operator overload for when a DateTime instance is
    * assigned to a Date.  We do a copy of the DateTime's
    * date-related components.
@@ -329,7 +313,7 @@
    *
    * @param C-String to fill.
    * @param Length of to C-String
-   * @returns length of string written (not including trailing '\0').
+   * @returns length of string written (including trailing '\0').
    *          If output was truncated, returns length that would have
    *          been outputted.
    */
@@ -349,7 +333,7 @@
    * successful.
    *
    * @param String to convert from
-   * @param Length of supplied string
+   * @param Length of supplied string (not including trailing '\0').
    */
   virtual bool from_string(const char *from, size_t from_len);
 

=== modified file 'drizzled/temporal_format.cc'
--- drizzled/temporal_format.cc	2010-02-04 08:14:46 +0000
+++ drizzled/temporal_format.cc	2010-06-03 21:38:52 +0000
@@ -237,7 +237,7 @@
 , {"^(\\d{2})[-/.](\\d{1,2})[-/.](\\d{1,2})[\\s+](\\d{2}):(\\d{2}):(\\d{2})$", 1, 2, 3, 4, 5, 6, 0, 0} /* YY[/-.][M]M[/-.][D]D HH:mm:SS */
 , {"^(\\d{2})[-/.](\\d{1,2})[-/.](\\d{1,2})[\\s+](\\d{2}):(\\d{2})$", 1, 2, 3, 4, 5, 0, 0, 0} /* YY[/-.][M]M[/-.][D]D HH:mm */
 , {"^(\\d{4})[-/.](\\d{1,2})[-/.](\\d{1,2})[\\s+](\\d{2}):(\\d{2})$", 1, 2, 3, 4, 5, 0, 0, 0} /* YYYY[/-.][M]M[/-.][D]D HH:mm */
-, {"^(\\d{4})[-/.](\\d{1,2})[-/.](\\d{1,2})$", 1, 2, 3, 0, 0, 0, 0, 0} /* YYYY-[M]M-[D]D, YYYY.[M]M.[D]D, YYYY/[M]M/[D]D */
+, {"^(\\d{4})[-/.](\\d{1,2})[-/.](\\d{1,2})$", 1, 2, 3, 0, 0, 0, 0, 0} /* YYYY-[M]M-[D]D, YYYY.[M]M.[D]D, YYYY/[M]M/[D]D */ 
 , {"^(\\d{4})(\\d{2})(\\d{2})$", 1, 2, 3, 0, 0, 0, 0, 0} /* YYYYMMDD */
 , {"^(\\d{2})[-/.]*(\\d{2})[-/.]*(\\d{4})$", 3, 1, 2, 0, 0, 0, 0, 0} /* MM[-/.]DD[-/.]YYYY (US common format)*/
 , {"^(\\d{2})[-/.]*(\\d{2})[-/.]*(\\d{2})$", 1, 2, 3, 0, 0, 0, 0, 0} /* YY[-/.]MM[-/.]DD */

=== modified file 'drizzled/temporal_interval.cc'
--- drizzled/temporal_interval.cc	2010-02-04 08:14:46 +0000
+++ drizzled/temporal_interval.cc	2010-06-06 20:55:30 +0000
@@ -311,7 +311,7 @@
     const char *start= str;
     for (value= 0 ; str != end && my_isdigit(cs,*str) ; str++)
       value= value * 10L + (int64_t) (*str - '0');
-    if (transform_msec && x == count - 1) // microseconds always last
+    if (transform_msec && (x == count - 1 || str == end)) // microseconds always last
     {
       long msec_length= 6 - (str - start);
       if (msec_length > 0)
@@ -323,7 +323,7 @@
     if (str == end && x != count-1)
     {
       x++;
-      /* Change values[0...x-1] -> values[0...count-1] */
+      /* Change values[0...x-1] -> values[count-x...count-1] */
       internal::bmove_upp((unsigned char*) (values+count),
                           (unsigned char*) (values+x),
                           sizeof(*values)*x);

=== modified file 'drizzled/temporal_interval.h'
--- drizzled/temporal_interval.h	2010-02-04 08:14:46 +0000
+++ drizzled/temporal_interval.h	2010-06-06 23:39:55 +0000
@@ -73,7 +73,7 @@
    * Sets whether or not this object specifies a negative interval
    * @param[in] in_neg true if this is a negative interval, false if not
    */
-  void setNegative(bool in_neg= true)
+  inline void setNegative(bool in_neg= true)
   {
     neg= in_neg;
   }
@@ -81,7 +81,7 @@
   /**
    * reverse boolean value of the negative flag
    */
-  void toggleNegative()
+  inline void toggleNegative()
   {
     neg= !neg;
   }
@@ -90,11 +90,32 @@
    * @retval true this is a negative temporal interval
    * @retval false this is a positive temporal interval
    */
-  bool getNegative() const
+  inline bool getNegative() const
   {
     return neg;
   }
 
+  inline uint32_t  get_year() { return year; };
+  inline void set_year(uint32_t new_year) { year = new_year; };
+
+  inline uint32_t  get_month(){ return month; };
+  inline void set_month(uint32_t new_month) { month = new_month; };
+
+  inline uint32_t  get_day(){ return day; };
+  inline void set_day(uint32_t new_day) { day = new_day; };
+
+  inline uint32_t  get_hour(){ return hour; };
+  inline void set_hour(uint32_t new_hour) { hour = new_hour; };
+
+  inline uint64_t  get_minute(){ return minute; };
+  inline void set_minute(uint32_t new_minute) { minute = new_minute; };
+
+  inline uint64_t  get_second(){ return second; };
+  inline void set_second(uint32_t new_second) { second = new_second; };
+
+  inline uint64_t  get_second_part(){ return second_part; };
+  inline void set_second_part(uint32_t new_second_part) { second_part = new_second_part; };
+
   /**
    * Populate this TemporalInterval from a string value
    *

=== modified file 'unittests/calendar_test.cc' (properties changed: -x to +x)
--- unittests/calendar_test.cc	2010-06-02 22:35:45 +0000
+++ unittests/calendar_test.cc	2010-06-05 21:39:51 +0000
@@ -29,7 +29,7 @@
 TEST(calendar_julian_day_number_from_gregorian_date_test, CalculationTest)
 {
   uint32_t year, month, day;
-  
+
   year= 2010; month= 4; day= 2;
   EXPECT_EQ(2455289, julian_day_number_from_gregorian_date(year, month, day));
   
@@ -129,4 +129,3 @@
   year= 2020; month= 7; day= 13; hour= 16; minute= 56; second= 59;
   EXPECT_TRUE(in_unix_epoch_range(year, month, day, hour, minute, second));
 }
-

=== added file 'unittests/date_test.cc'
--- unittests/date_test.cc	1970-01-01 00:00:00 +0000
+++ unittests/date_test.cc	2010-06-09 17:12:30 +0000
@@ -0,0 +1,522 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Pawel Blokus
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <gtest/gtest.h>
+#include <drizzled/decimal.h>
+#include <drizzled/temporal.h>
+#include <drizzled/temporal_format.h>
+
+#include "temporal_generator.h"
+
+using namespace drizzled;
+
+template <typename TemporalType>
+class DateTestCompareOperators : public ::testing::Test
+{
+ protected:
+  Date sample_date;
+  bool result;
+  
+  TemporalType identical_with_sample_date, before_sample_date, after_sample_date;
+  
+  void initBeforeIdenticalAfter();
+
+  virtual void SetUp()
+  {
+    TemporalGenerator::DateGen::make_date(&sample_date, 2010, 9, 8);
+    initBeforeIdenticalAfter();
+  }
+};
+
+template<> void DateTestCompareOperators<Date>::initBeforeIdenticalAfter()
+{
+  TemporalGenerator::DateGen::make_date(&before_sample_date, 1980, 1, 1);
+  TemporalGenerator::DateGen::make_date(&identical_with_sample_date, 2010, 9, 8);
+  TemporalGenerator::DateGen::make_date(&after_sample_date, 2019, 5, 30);
+}
+
+template<> void DateTestCompareOperators<DateTime>::initBeforeIdenticalAfter()
+{
+  TemporalGenerator::DateTimeGen::make_datetime(&before_sample_date, 1990, 12, 31, 12, 12, 30);
+  TemporalGenerator::DateTimeGen::make_datetime(&identical_with_sample_date, 2010, 9, 8, 0, 0, 0);
+  TemporalGenerator::DateTimeGen::make_datetime(&after_sample_date, 2020, 4, 4, 4, 4, 4);
+}
+
+template<> void DateTestCompareOperators<Timestamp>::initBeforeIdenticalAfter()
+{
+  TemporalGenerator::TimestampGen::make_timestamp(&before_sample_date, 1980, 1, 1, 13, 56, 41);
+  TemporalGenerator::TimestampGen::make_timestamp(&identical_with_sample_date, 2010, 9, 8, 0, 0, 0);
+  TemporalGenerator::TimestampGen::make_timestamp(&after_sample_date, 2019, 5, 30, 9, 10, 13);
+}
+
+typedef ::testing::Types<Date, DateTime, Timestamp> typesForDateTestCompareOperators;
+TYPED_TEST_CASE(DateTestCompareOperators, typesForDateTestCompareOperators);
+
+TYPED_TEST(DateTestCompareOperators, operatorEqual_ComparingWithIdencticalTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_date == this->identical_with_sample_date);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TYPED_TEST(DateTestCompareOperators, operatorEqual_ComparingWithDifferentTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_date == this->before_sample_date);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TYPED_TEST(DateTestCompareOperators, operatorNotEqual_ComparingWithIdencticalTemporal_ShouldReturn_False)
+{ 
+  this->result= (this->sample_date != this->identical_with_sample_date);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TYPED_TEST(DateTestCompareOperators, operatorNotEqual_ComparingWithDifferentTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_date != this->before_sample_date);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TYPED_TEST(DateTestCompareOperators, operatorGreaterThan_ComparingWithIdenticalTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_date > this->identical_with_sample_date);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TYPED_TEST(DateTestCompareOperators, operatorGreaterThan_ComparingWithLaterTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_date > this->after_sample_date);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TYPED_TEST(DateTestCompareOperators, operatorGreaterThan_ComparingWithEarlierTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_date > this->before_sample_date);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TYPED_TEST(DateTestCompareOperators, operatorGreaterThanOrEqual_ComparingWithIdenticalTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_date >= this->identical_with_sample_date);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TYPED_TEST(DateTestCompareOperators, operatorGreaterThanOrEqual_ComparingWithLaterTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_date >= this->after_sample_date);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TYPED_TEST(DateTestCompareOperators, operatorGreaterThanOrEqual_ComparingWithEarlierTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_date >= this->before_sample_date);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TYPED_TEST(DateTestCompareOperators, operatorLessThan_ComparingWithIdenticalTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_date < this->identical_with_sample_date);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TYPED_TEST(DateTestCompareOperators, operatorLessThan_ComparingWithLaterTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_date < this->after_sample_date);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TYPED_TEST(DateTestCompareOperators, operatorLessThan_ComparingWithEarlierTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_date < this->before_sample_date);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TYPED_TEST(DateTestCompareOperators, operatorLessThanOrEqual_ComparingWithIdenticalTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_date <= this->identical_with_sample_date);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TYPED_TEST(DateTestCompareOperators, operatorLessThanOrEqual_ComparingWithLaterTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_date <= this->after_sample_date);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TYPED_TEST(DateTestCompareOperators, operatorLessThanOrEqual_ComparingWithEarlierTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_date <= this->before_sample_date);
+  
+  ASSERT_FALSE(this->result);
+}
+
+class DateTest : public ::testing::Test
+{
+  protected:
+    Date date;
+    bool result;
+    
+    virtual void SetUp()
+    {
+      TemporalGenerator::DateGen::make_valid_date(&date);
+    }
+};
+
+TEST_F(DateTest, operatorAssign_shouldCopyDateRelatadComponents)
+{
+  Date copy= date;
+
+  EXPECT_EQ(date.years(), copy.years());
+  EXPECT_EQ(date.months(), copy.months());
+  EXPECT_EQ(date.days(), copy.days());
+}
+
+TEST_F(DateTest, is_valid_onValidDate_shouldReturn_True)
+{
+  result= date.is_valid();
+  ASSERT_TRUE(result);
+}
+
+TEST_F(DateTest, is_valid_onInvalidDateWithYearBelowMinimum_shouldReturn_False)
+{
+  date.set_years(DRIZZLE_MIN_YEARS_SQL - 1);
+  
+  result= date.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(DateTest, is_valid_onInvalidDateWithYearAboveMaximum_shouldReturn_False)
+{
+  date.set_years(DRIZZLE_MAX_YEARS_SQL + 1);
+    
+  result= date.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(DateTest, is_valid_onInvalidDateWithMonthSetToZero_shouldReturn_False)
+{
+  date.set_months(0);
+  
+  result= date.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+
+TEST_F(DateTest, is_valid_onInvalidDateWithMonthAboveMaximum_shouldReturn_False)
+{
+  date.set_months(13);
+  
+  result= date.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(DateTest, is_valid_onInvalidDateWithDaySetToZero_shouldReturn_False)
+{
+  date.set_days(0);
+  
+  result= date.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(DateTest, is_valid_onInvalidDateWithDayAboveDaysInMonth_shouldReturn_False)
+{
+  date.set_days(32);
+  
+  result= date.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(DateTest, is_valid_onInvalidDateWithLeapDayInNonLeapYear_shouldReturn_False)
+{
+  TemporalGenerator::TemporalGen::leap_day_in_non_leap_year(&date);
+  
+  result= date.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(DateTest, is_valid_onValidDateWithLeapDayInLeapYear_shouldReturn_True)
+{
+  TemporalGenerator::TemporalGen::leap_day_in_leap_year(&date);
+  
+  result= date.is_valid();
+  
+  ASSERT_TRUE(result);
+}
+
+TEST_F(DateTest, to_string_shouldProduce_hyphenSeperatedDateElements)
+{
+  char expected[Date::MAX_STRING_LENGTH]= "2010-05-01";
+  char returned[Date::MAX_STRING_LENGTH];
+  TemporalGenerator::DateGen::make_date(&date, 2010, 5, 1);
+  
+  date.to_string(returned, Date::MAX_STRING_LENGTH);
+  
+  ASSERT_STREQ(expected, returned);  
+}
+
+TEST_F(DateTest, to_string_nullBuffer_shouldReturnProperLengthAnyway)
+{
+  int length= date.to_string(NULL, 0);
+  
+  ASSERT_EQ(Date::MAX_STRING_LENGTH - 1, length);  
+}
+
+TEST_F(DateTest, from_string_validString_shouldPopulateCorrectly)
+{
+  char valid_string[Date::MAX_STRING_LENGTH]= "2010-05-01";
+  uint32_t years, months, days;
+
+  init_temporal_formats();
+  
+  result= date.from_string(valid_string, Date::MAX_STRING_LENGTH - 1);
+  ASSERT_TRUE(result);
+  
+  years= date.years();
+  months= date.months();
+  days= date.days();
+
+  deinit_temporal_formats();
+  
+  EXPECT_EQ(2010, years);
+  EXPECT_EQ(5, months);
+  EXPECT_EQ(1, days);
+}
+
+TEST_F(DateTest, from_string_invalidString_shouldReturn_False)
+{
+  char valid_string[Date::MAX_STRING_LENGTH]= "2x10-05-01";
+
+  init_temporal_formats();
+  result= date.from_string(valid_string, Date::MAX_STRING_LENGTH - 1);
+  deinit_temporal_formats();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(DateTest, to_int64_t)
+{
+  TemporalGenerator::DateGen::make_date(&date, 2030, 8, 17);
+  int64_t representation;
+  
+  date.to_int64_t(&representation);
+  
+  ASSERT_EQ(20300817, representation);
+}
+
+TEST_F(DateTest, to_int32_t)
+{
+  TemporalGenerator::DateGen::make_date(&date, 2030, 8, 17);
+  int32_t representation;
+
+  date.to_int32_t(&representation);
+
+  ASSERT_EQ(20300817, representation);
+}
+
+TEST_F(DateTest, from_int32_t_shouldPopulateDateCorrectly)
+{
+  uint32_t decoded_years, decoded_months, decoded_days;
+
+  date.from_int32_t(20300817);
+  
+  decoded_years= date.years();
+  decoded_months= date.months();
+  decoded_days= date.days();
+  
+  EXPECT_EQ(2030, decoded_years);
+  EXPECT_EQ(8, decoded_months);
+  EXPECT_EQ(17, decoded_days);
+}
+
+TEST_F(DateTest, to_julian_day_number)
+{
+  int64_t julian_day;
+  TemporalGenerator::DateGen::make_date(&date, 1999, 12, 31);
+  
+  date.to_julian_day_number(&julian_day);
+  
+  ASSERT_EQ(2451544, julian_day);
+}
+
+TEST_F(DateTest, from_julian_day_number)
+{
+  int64_t julian_day= 2451544;
+  uint32_t years, months, days;
+   
+  date.from_julian_day_number(julian_day);
+  
+  years= date.years();
+  months= date.months();
+  days= date.days();
+    
+  EXPECT_EQ(1999, years);
+  EXPECT_EQ(12, months);
+  EXPECT_EQ(31, days);
+}
+
+TEST_F(DateTest, DISABLED_to_tm)
+{
+  uint32_t years= 2030, months= 8, days= 17;
+  TemporalGenerator::DateGen::make_date(&date, years, months, days);
+  struct tm filled;
+  
+  date.to_tm(&filled);
+  
+  EXPECT_EQ(130, filled.tm_year);
+  EXPECT_EQ(7, filled.tm_mon);
+  EXPECT_EQ(17, filled.tm_mday);
+  EXPECT_EQ(0, filled.tm_hour);
+  EXPECT_EQ(0, filled.tm_min);
+  EXPECT_EQ(0, filled.tm_sec);
+
+  /* TODO:these fail, shouldn't they also be set properly? */
+  EXPECT_EQ(228, filled.tm_yday);
+  EXPECT_EQ(6, filled.tm_wday);
+  EXPECT_EQ(-1, filled.tm_isdst);
+}
+
+TEST_F(DateTest, from_tm)
+{
+  uint32_t years, months, days;
+  struct tm from;
+  from.tm_year= 1956 - 1900;
+  from.tm_mon= 2;
+  from.tm_mday= 30;
+  
+  date.from_tm(&from);
+  
+  years= date.years();
+  months= date.months();
+  days= date.days();
+  
+  EXPECT_EQ(1956, years);  
+  EXPECT_EQ(3, months);
+  EXPECT_EQ(30, days);
+}
+
+TEST_F(DateTest, to_time_t)
+{
+  time_t time;
+  TemporalGenerator::DateGen::make_date(&date, 1990, 9, 9);
+  
+  date.to_time_t(&time);
+  
+  ASSERT_EQ(652838400, time);
+}
+
+TEST_F(DateTest, from_time_t)
+{
+  uint32_t years, months, days;
+  
+  date.from_time_t(652838400);
+  
+  years= date.years();
+  months= date.months();
+  days= date.days();
+  
+  EXPECT_EQ(1990, years);  
+  EXPECT_EQ(9, months);
+  EXPECT_EQ(9, days);
+}
+
+TEST_F(DateTest, to_decimal)
+{
+  drizzled::my_decimal to;
+  TemporalGenerator::DateGen::make_date(&date, 1987, 5, 6);
+
+  date.to_decimal(&to);
+
+  ASSERT_EQ(19870506, to.buf[0]);
+}
+
+class DateFromStringTest: public ::testing::TestWithParam<const char*>
+{
+  protected:
+    Date date;
+    bool result;
+    uint32_t years, months, days;
+    
+    virtual void SetUp()
+    {
+      init_temporal_formats();
+    }
+    
+    virtual void TearDown()
+    {
+      deinit_temporal_formats();
+    }
+    
+    void assign_date_values()
+    {
+      years= date.years();
+      months= date.months();
+      days= date.days();
+    }
+};
+
+TEST_P(DateFromStringTest, from_string)
+{
+  const char *valid_string= GetParam();
+  
+  result= date.from_string(valid_string, strlen(valid_string));
+  ASSERT_TRUE(result);
+  
+  assign_date_values();
+  
+  EXPECT_EQ(2010, years);
+  EXPECT_EQ(6, months);
+  EXPECT_EQ(7, days);
+}
+
+/* TODO:for some reason this was not declared by the macro, needs clarification*/
+testing::internal::ParamGenerator<const char*> gtest_ValidStringDateFromStringTest_EvalGenerator_();
+
+INSTANTIATE_TEST_CASE_P(ValidString, DateFromStringTest,
+                        ::testing::Values("20100607", /* YYYYMMDD */
+                                          "06/07/2010",/* MM[-/.]DD[-/.]YYYY (US common format)*/
+                                          "10.06.07",/* YY[-/.]MM[-/.]DD */
+                                          "10/6/7",/* YY[-/.][M]M[-/.][D]D */
+                                          "2010-6-7"/* YYYY[-/.][M]M[-/.][D]D */));
+                                          
+
+                                          
\ No newline at end of file

=== added file 'unittests/date_time_test.cc'
--- unittests/date_time_test.cc	1970-01-01 00:00:00 +0000
+++ unittests/date_time_test.cc	2010-06-09 17:12:30 +0000
@@ -0,0 +1,460 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+*  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+*
+*  Copyright (C) 2010 Pawel Blokus
+*
+*  This program is free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License as published by
+*  the Free Software Foundation; either version 2 of the License, or
+*  (at your option) any later version.
+*
+*  This program is distributed in the hope that it will be useful,
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*  GNU General Public License for more details.
+*
+*  You should have received a copy of the GNU General Public License
+*  along with this program; if not, write to the Free Software
+*  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+*/
+
+#include "config.h"
+
+#include <gtest/gtest.h>
+#include <drizzled/decimal.h>
+#include <drizzled/temporal.h>
+#include <drizzled/temporal_format.h>
+
+#include "temporal_generator.h"
+
+using namespace drizzled;
+
+class DateTimeTest: public ::testing::Test
+{
+  protected:
+    DateTime datetime;
+    bool result;
+    uint32_t years, months, days;
+    uint32_t hours, minutes, seconds;
+    
+    virtual void SetUp()
+    {
+      TemporalGenerator::DateTimeGen::make_valid_datetime(&datetime);
+    }
+
+    void assignDateTimeValues()
+    {
+      years= datetime.years();
+      months= datetime.months();
+      days= datetime.days();
+      hours= datetime.hours();
+      minutes= datetime.minutes();
+      seconds= datetime.seconds();
+    }
+};
+
+TEST_F(DateTimeTest, is_valid_onValidDateTime_shouldReturn_True)
+{
+  result= datetime.is_valid();
+  ASSERT_TRUE(result);
+}
+
+TEST_F(DateTimeTest, is_valid_onInvalidDateTimeWithYearBelowMinimum_shouldReturn_False)
+{
+  datetime.set_years(DRIZZLE_MIN_YEARS_SQL - 1);
+  
+  result= datetime.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(DateTimeTest, is_valid_onInvalidDateTimeWithYearAboveMaximum_shouldReturn_False)
+{
+  datetime.set_years(DRIZZLE_MAX_YEARS_SQL + 1);
+    
+  result= datetime.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(DateTimeTest, is_valid_onInvalidDateTimeWithMonthSetToZero_shouldReturn_False)
+{
+  datetime.set_months(0);
+  
+  result= datetime.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+
+TEST_F(DateTimeTest, is_valid_onInvalidDateTimeWithMonthAboveMaximum_shouldReturn_False)
+{
+  datetime.set_months(13);
+  
+  result= datetime.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(DateTimeTest, is_valid_onInvalidDateTimeWithDaySetToZero_shouldReturn_False)
+{
+  datetime.set_days(0);
+  
+  result= datetime.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(DateTimeTest, is_valid_onInvalidDateTimeWithDayAboveDaysInMonth_shouldReturn_False)
+{
+  datetime.set_days(32);
+  
+  result= datetime.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(DateTimeTest, is_valid_onInvalidDateTimeWithLeapDayInNonLeapYear_shouldReturn_False)
+{
+  TemporalGenerator::TemporalGen::leap_day_in_non_leap_year(&datetime);
+  
+  result= datetime.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(DateTimeTest, is_valid_onValidDateTimeWithLeapDayInLeapYear_shouldReturn_True)
+{
+  TemporalGenerator::TemporalGen::leap_day_in_leap_year(&datetime);
+  
+  result= datetime.is_valid();
+  
+  ASSERT_TRUE(result);
+}
+
+TEST_F(DateTimeTest, is_valid_onValidMinimalTime_shouldReturn_True)
+{
+  TemporalGenerator::TemporalGen::make_min_time(&datetime);
+  
+  result= datetime.is_valid();
+  
+  ASSERT_TRUE(result);
+}
+
+TEST_F(DateTimeTest, is_valid_onValidMaximalTime_shouldReturn_True)
+{
+  TemporalGenerator::TemporalGen::make_max_time(&datetime);
+  
+  result= datetime.is_valid();
+  
+  ASSERT_TRUE(result);
+}
+
+TEST_F(DateTimeTest, is_valid_onInvalidDateTimeWithHourAboveMaximum23_shouldReturn_False)
+{
+  datetime.set_hours(24);
+  
+  result= datetime.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(DateTimeTest, is_valid_onInvalidDateTimeWithMinutesAboveMaximum59_shouldReturn_False)
+{
+  datetime.set_minutes(60);
+  
+  result= datetime.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(DateTimeTest, is_valid_onInvalidDateTimeWithSecondsAboveMaximum61_shouldReturn_False)
+{
+  datetime.set_seconds(62);
+  
+  result= datetime.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(DateTimeTest, to_string_shouldProduce_hyphenSeperatedDateElements_and_colonSeperatedTimeElements)
+{
+  char expected[DateTime::MAX_STRING_LENGTH]= "2010-05-01 08:07:06.123456";
+  char returned[DateTime::MAX_STRING_LENGTH];
+  TemporalGenerator::DateTimeGen::make_datetime(&datetime, 2010, 5, 1, 8, 7, 6, 123456);
+  
+  datetime.to_string(returned, DateTime::MAX_STRING_LENGTH);
+  
+  ASSERT_STREQ(expected, returned);
+}
+
+TEST_F(DateTimeTest, to_string_nullBuffer_noMicroSeconds_shouldReturnProperLengthAnyway)
+{
+  int length= datetime.to_string(NULL, 0);
+  
+  ASSERT_EQ(DateTime::MAX_STRING_LENGTH - 1 - 7, length);  
+}
+
+TEST_F(DateTimeTest, to_int64_t)
+{
+  TemporalGenerator::DateTimeGen::make_datetime(&datetime, 2030, 8, 7, 14, 5, 13);
+  int64_t representation;
+
+  datetime.to_int64_t(&representation);
+
+  ASSERT_EQ(20300807140513LL, representation);
+}
+
+TEST_F(DateTimeTest, from_int64_t_no_conversion_format_YYYYMMDDHHMMSSshouldPopulateDateTimeCorrectly)
+{
+  datetime.from_int64_t(20300807140513LL, false);
+  
+  assignDateTimeValues();
+  
+  EXPECT_EQ(2030, years);
+  EXPECT_EQ(8, months);
+  EXPECT_EQ(7, days);
+  EXPECT_EQ(14, hours);
+  EXPECT_EQ(5, minutes);
+  EXPECT_EQ(13, seconds);
+}
+
+TEST_F(DateTimeTest, from_int64_t_with_conversion_format_YYYYMMDDHHMMSS_yearOver2000)
+{
+  datetime.from_int64_t(20300807140513LL, true);
+  
+  assignDateTimeValues();
+  
+  EXPECT_EQ(2030, years);
+  EXPECT_EQ(8, months);
+  EXPECT_EQ(7, days);
+  EXPECT_EQ(14, hours);
+  EXPECT_EQ(5, minutes);
+  EXPECT_EQ(13, seconds);
+}
+
+TEST_F(DateTimeTest, from_int64_t_with_conversion_format_YYYYMMDDHHMMSS_yearBelow2000)
+{
+  datetime.from_int64_t(19900807140513LL, true);
+  
+  assignDateTimeValues();
+  
+  EXPECT_EQ(1990, years);
+  EXPECT_EQ(8, months);
+  EXPECT_EQ(7, days);
+  EXPECT_EQ(14, hours);
+  EXPECT_EQ(5, minutes);
+  EXPECT_EQ(13, seconds);
+}
+
+TEST_F(DateTimeTest, from_int64_t_with_conversion_format_YYMMDDHHMMSS_yearOver2000)
+{
+  datetime.from_int64_t(300807140513LL, true);
+  
+  assignDateTimeValues();
+  
+  EXPECT_EQ(2030, years);
+  EXPECT_EQ(8, months);
+  EXPECT_EQ(7, days);
+  EXPECT_EQ(14, hours);
+  EXPECT_EQ(5, minutes);
+  EXPECT_EQ(13, seconds);
+}
+
+TEST_F(DateTimeTest, from_int64_t_with_conversion_format_YYMMDDHHMMSS_yearBelow2000)
+{
+  datetime.from_int64_t(900807140513LL, true);
+  
+  assignDateTimeValues();
+  
+  EXPECT_EQ(1990, years);
+  EXPECT_EQ(8, months);
+  EXPECT_EQ(7, days);
+  EXPECT_EQ(14, hours);
+  EXPECT_EQ(5, minutes);
+  EXPECT_EQ(13, seconds);
+}
+
+TEST_F(DateTimeTest, DISABLED_to_tm)
+{
+  years= 2030, months= 8, days= 17, hours= 14, minutes= 45, seconds= 13;
+  TemporalGenerator::DateTimeGen::make_datetime(&datetime, years, months, days, hours, minutes, seconds);
+  struct tm filled;
+  
+  datetime.to_tm(&filled);
+  
+  EXPECT_EQ(2030 - 1900, filled.tm_year);
+  EXPECT_EQ(8 - 1, filled.tm_mon);
+  EXPECT_EQ(17, filled.tm_mday);
+  EXPECT_EQ(14, filled.tm_hour);
+  EXPECT_EQ(45, filled.tm_min);
+  EXPECT_EQ(13, filled.tm_sec);
+
+  /* TODO:these fail, shouldn't they also be set properly? */
+  EXPECT_EQ(228, filled.tm_yday);
+  EXPECT_EQ(6, filled.tm_wday);
+  EXPECT_EQ(-1, filled.tm_isdst);
+}
+
+TEST_F(DateTimeTest, to_decimal)
+{
+  drizzled::my_decimal to;
+  TemporalGenerator::DateTimeGen::make_datetime(&datetime, 1987, 6, 13, 5, 10, 13, 456);
+
+  datetime.to_decimal(&to);
+  
+  EXPECT_EQ(19870,to.buf[0]);
+  EXPECT_EQ(613051013,to.buf[1]);
+  EXPECT_EQ(456000,to.buf[2]);
+}
+
+
+
+class DateTimeFromStringTest
+{
+  protected:
+    DateTime datetime;
+    bool result;
+    uint32_t years, months, days;
+    uint32_t hours, minutes, seconds;
+
+    void init()
+    {
+      init_temporal_formats();
+    }
+
+    void deinit()
+    {
+      deinit_temporal_formats();
+    }
+
+    void assignDateTimeValues()
+    {
+      years= datetime.years();
+      months= datetime.months();
+      days= datetime.days();
+      hours= datetime.hours();
+      minutes= datetime.minutes();
+      seconds= datetime.seconds();
+    }
+};
+
+class DateTimeFromStringFullFormatTest: public ::testing::TestWithParam<const char*>, public DateTimeFromStringTest
+{
+  virtual void SetUp()
+  {
+    init();
+  }
+  
+  virtual void TearDown()
+  {
+    deinit();
+  }  
+};
+
+class DateTimeFromStringNoSecondFormatTest: public ::testing::TestWithParam<const char*>, public DateTimeFromStringTest
+{
+  virtual void SetUp()
+  {
+    init();
+  }
+  
+  virtual void TearDown()
+  {
+    deinit();
+  }
+};
+
+class DateTimeFromStringDateOnlyTest: public ::testing::TestWithParam<const char*>, public DateTimeFromStringTest
+{
+  virtual void SetUp()
+  {
+    init();
+  }
+  
+  virtual void TearDown()
+  {
+    deinit();
+  }
+};
+
+TEST_P(DateTimeFromStringFullFormatTest, from_string_validString)
+{
+  const char *valid_string= GetParam();
+
+  result= datetime.from_string(valid_string, strlen(valid_string));
+  ASSERT_TRUE(result);
+
+  assignDateTimeValues();
+
+  EXPECT_EQ(2010, years);
+  EXPECT_EQ(5, months);
+  EXPECT_EQ(1, days);
+  EXPECT_EQ(8, hours);
+  EXPECT_EQ(7, minutes);
+  EXPECT_EQ(6, seconds);
+}
+/* TODO:for some reason this was not declared by the macro, needs clarification*/
+testing::internal::ParamGenerator<const char*> gtest_ValidStringDateTimeFromStringFullFormatTest_EvalGenerator_();
+INSTANTIATE_TEST_CASE_P(ValidString, DateTimeFromStringFullFormatTest,
+                        ::testing::Values("20100501080706",
+                                          "2010-05-01 08:07:06",
+                                          "2010/05/01T08:07:06",
+                                          "2010.5.1 08:07:06",
+                                          "10-05-01 08:07:06",
+                                          "10/5/1 08:07:06",
+                                          "10.5.1 08:07:06"));
+
+                                          
+TEST_P(DateTimeFromStringNoSecondFormatTest, from_string_validString)
+{
+  const char *valid_string= GetParam();
+
+  result= datetime.from_string(valid_string, strlen(valid_string));
+  ASSERT_TRUE(result);
+
+  assignDateTimeValues();
+
+  EXPECT_EQ(2010, years);
+  EXPECT_EQ(5, months);
+  EXPECT_EQ(1, days);
+  EXPECT_EQ(8, hours);
+  EXPECT_EQ(7, minutes);
+}
+
+/* TODO:for some reason this was not declared by the macro, needs clarification*/
+testing::internal::ParamGenerator<const char*> gtest_ValidStringDateTimeFromStringNoSecondFormatTest_EvalGenerator_();
+INSTANTIATE_TEST_CASE_P(ValidString, DateTimeFromStringNoSecondFormatTest,
+                        ::testing::Values("2010-05-01 08:07",
+                                          "2010/05/01 08:07",
+                                          "2010.5.1 08:07",
+                                          "10-05-01 08:07",
+                                          "10/5/1 08:07",
+                                          "10.5.1 08:07"));
+
+
+
+TEST_P(DateTimeFromStringDateOnlyTest, from_string_validString)
+{
+  const char *valid_string= GetParam();
+
+  result= datetime.from_string(valid_string, strlen(valid_string));
+  ASSERT_TRUE(result);
+
+  assignDateTimeValues();
+
+  EXPECT_EQ(2010, years);
+  EXPECT_EQ(6, months);
+  EXPECT_EQ(7, days);
+}
+
+/* TODO:for some reason this was not declared by the macro, needs clarification*/
+testing::internal::ParamGenerator<const char*> gtest_ValidStringDateTimeFromStringDateOnlyTest_EvalGenerator_();
+INSTANTIATE_TEST_CASE_P(ValidString, DateTimeFromStringDateOnlyTest,
+                        ::testing::Values("20100607", /* YYYYMMDD */
+                                          "06/07/2010",/* MM[-/.]DD[-/.]YYYY (US common format)*/
+                                          "10.06.07",/* YY[-/.]MM[-/.]DD */
+                                          "10/6/7",/* YY[-/.][M]M[-/.][D]D */
+                                          "2010-6-7"/* YYYY[-/.][M]M[-/.][D]D */));
+
+                                          
\ No newline at end of file

=== modified file 'unittests/include.am' (properties changed: -x to +x)
--- unittests/include.am	2010-06-15 13:37:26 +0000
+++ unittests/include.am	2010-06-15 23:59:32 +0000
@@ -3,18 +3,29 @@
 # All paths should be given relative to the root
 
 if HAVE_LIBGTEST
-check_PROGRAMS += 	unittests/unittests
+check_PROGRAMS += unittests/unittests
 
-unittests_unittests_SOURCES= \
-			     unittests/atomics_test.cc \
-			     unittests/calendar_test.cc \
-			     unittests/main.cc \
-			     unittests/table_identifier.cc \
-			     unittests/pthread_atomics_test.cc \
-			     unittests/utf8_test.cc
+unittests_unittests_SOURCES = \
+			      unittests/atomics_test.cc \
+			      unittests/calendar_test.cc \
+			      unittests/date_test.cc \
+			      unittests/date_time_test.cc \
+			      unittests/main.cc \
+			      unittests/micro_timestamp_test.cc \
+			      unittests/nano_timestamp_test.cc \
+			      unittests/plugin/authentication_test.cc \
+			      unittests/plugin/client_test.cc \
+			      unittests/plugin/error_message_test.cc \
+			      unittests/pthread_atomics_test.cc \
+			      unittests/table_identifier.cc \
+			      unittests/temporal_format_test.cc \
+			      unittests/temporal_generator.cc \
+			      unittests/temporal_interval_test.cc \
+			      unittests/time_test.cc \
+			      unittests/timestamp_test.cc \
+			      unittests/utf8_test.cc
 
 unittests_unittests_LDADD= \
   $(filter-out drizzled/main.$(OBJEXT), ${am_drizzled_drizzled_OBJECTS}) \
   ${drizzled_drizzled_LDADD} ${LTLIBGTEST}
-
 endif

=== modified file 'unittests/main.cc'
--- unittests/main.cc	2010-06-02 22:35:45 +0000
+++ unittests/main.cc	2010-06-06 20:55:30 +0000
@@ -22,8 +22,11 @@
 
 #include <gtest/gtest.h>
 
+#include <drizzled/internal/my_sys.h>
+
 int main(int argc, char **argv)
 {
+	MY_INIT(argv[0]);
   ::testing::InitGoogleTest(&argc, argv);
   return RUN_ALL_TESTS();
 }

=== added file 'unittests/micro_timestamp_test.cc'
--- unittests/micro_timestamp_test.cc	1970-01-01 00:00:00 +0000
+++ unittests/micro_timestamp_test.cc	2010-06-09 17:12:30 +0000
@@ -0,0 +1,108 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Pawel Blokus
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <gtest/gtest.h>
+#include <drizzled/temporal.h>
+
+#include "temporal_generator.h"
+
+using namespace drizzled;
+
+class MicroTimestampTest : public ::testing::Test
+{
+  protected:
+    MicroTimestamp micro_timestamp;
+    bool result;
+};
+
+TEST_F(MicroTimestampTest, is_valid_minOfMicroTimestampRange_shouldReturn_True)
+{
+  uint32_t year= 1970, month= 1, day= 1, hour= 0, minute= 0, second= 0, microsecond= 0;
+  TemporalGenerator::TimestampGen::make_micro_timestamp(&micro_timestamp, year, month, day, hour, minute, second, microsecond);
+
+  result= micro_timestamp.is_valid();
+
+  ASSERT_TRUE(result);
+}
+
+TEST_F(MicroTimestampTest, is_valid_maxOfMicroTimestampRange_shouldReturn_True)
+{
+  uint32_t year= 2038, month= 1, day= 19, hour= 3, minute= 14, second= 7, microsecond= 0;
+  TemporalGenerator::TimestampGen::make_micro_timestamp(&micro_timestamp, year, month, day, hour, minute, second, microsecond);
+
+  result= micro_timestamp.is_valid();
+
+  ASSERT_TRUE(result);
+}
+
+TEST_F(MicroTimestampTest, is_valid_oneMicroSecondBeforeMicroTimestampMinOfRange_shouldReturn_False)
+{
+  uint32_t year= 1969, month= 12, day= 31, hour= 23, minute= 59, second= 59, microsecond= 999999;
+  TemporalGenerator::TimestampGen::make_micro_timestamp(&micro_timestamp, year, month, day, hour, minute, second, microsecond);
+
+  result= micro_timestamp.is_valid();
+
+  ASSERT_FALSE(result);
+}
+
+TEST_F(MicroTimestampTest, is_valid_oneMicroSecondAfterMicroTimestampMaxOfRange_shouldReturn_False)
+{
+  uint32_t year= 2038, month= 1, day= 19, hour= 3, minute= 14, second= 8, microsecond= 1;
+  TemporalGenerator::TimestampGen::make_micro_timestamp(&micro_timestamp, year, month, day, hour, minute, second, microsecond);
+
+  result= micro_timestamp.is_valid();
+
+  ASSERT_FALSE(result);
+}
+
+TEST_F(MicroTimestampTest, is_valid_InsideOfMicroTimestampRange_shouldReturn_True)
+{
+  uint32_t year= 1980, month= 11, day= 1, hour= 5, minute= 8, second= 5, microsecond= 18263;
+  TemporalGenerator::TimestampGen::make_micro_timestamp(&micro_timestamp, year, month, day, hour, minute, second, microsecond);
+
+  result= micro_timestamp.is_valid();
+
+  ASSERT_TRUE(result);
+}
+
+TEST_F(MicroTimestampTest, to_string_shouldProduce_hyphenSeperatedDateElements_and_colonSeperatedTimeElements)
+{
+  char expected[MicroTimestamp::MAX_STRING_LENGTH]= "2010-05-01 08:07:06.007654";
+  char returned[MicroTimestamp::MAX_STRING_LENGTH];
+  TemporalGenerator::TimestampGen::make_micro_timestamp(&micro_timestamp, 2010, 5, 1, 8, 7, 6, 7654);
+  
+  micro_timestamp.to_string(returned, MicroTimestamp::MAX_STRING_LENGTH);
+  
+  ASSERT_STREQ(expected, returned);
+}
+
+TEST_F(MicroTimestampTest, to_timeval)
+{
+  struct timeval filled;
+  uint32_t year= 2009, month= 6, day= 3, hour= 4, minute= 59, second= 1, microsecond= 675;
+  TemporalGenerator::TimestampGen::make_micro_timestamp(&micro_timestamp, year, month, day, hour, minute, second, microsecond);
+
+  micro_timestamp.to_timeval(&filled);
+
+  EXPECT_EQ(1244005141, filled.tv_sec);
+  EXPECT_EQ(675, filled.tv_usec);
+}

=== added file 'unittests/nano_timestamp_test.cc'
--- unittests/nano_timestamp_test.cc	1970-01-01 00:00:00 +0000
+++ unittests/nano_timestamp_test.cc	2010-06-09 17:12:30 +0000
@@ -0,0 +1,97 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Pawel Blokus
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <gtest/gtest.h>
+#include <drizzled/temporal.h>
+
+#include "temporal_generator.h"
+
+using namespace drizzled;
+
+class NanoTimestampTest : public ::testing::Test
+{
+  protected:
+    NanoTimestamp nano_timestamp;
+    bool result;
+};
+
+TEST_F(NanoTimestampTest, is_valid_minOfNanoTimestampRange_shouldReturn_True)
+{
+  uint32_t year= 1970, month= 1, day= 1, hour= 0, minute= 0, second= 0, nanosecond= 0;
+  TemporalGenerator::TimestampGen::make_nano_timestamp(&nano_timestamp, year, month, day, hour, minute, second, nanosecond);
+
+  result= nano_timestamp.is_valid();
+
+  ASSERT_TRUE(result);
+}
+
+TEST_F(NanoTimestampTest, is_valid_maxOfNanoTimestampRange_shouldReturn_True)
+{
+  uint32_t year= 2038, month= 1, day= 19, hour= 3, minute= 14, second= 7, nanosecond= 0;
+  TemporalGenerator::TimestampGen::make_nano_timestamp(&nano_timestamp, year, month, day, hour, minute, second, nanosecond);
+
+  result= nano_timestamp.is_valid();
+
+  ASSERT_TRUE(result);
+}
+
+TEST_F(NanoTimestampTest, is_valid_oneMicroSecondBeforeNanoTimestampMinOfRange_shouldReturn_False)
+{
+  uint32_t year= 1969, month= 12, day= 31, hour= 23, minute= 59, second= 59, nanosecond= 999999999;
+  TemporalGenerator::TimestampGen::make_nano_timestamp(&nano_timestamp, year, month, day, hour, minute, second, nanosecond);
+
+  result= nano_timestamp.is_valid();
+
+  ASSERT_FALSE(result);
+}
+
+TEST_F(NanoTimestampTest, is_valid_oneMicroSecondAfterNanoTimestampMaxOfRange_shouldReturn_False)
+{
+  uint32_t year= 2038, month= 1, day= 19, hour= 3, minute= 14, second= 8, nanosecond= 1;
+  TemporalGenerator::TimestampGen::make_nano_timestamp(&nano_timestamp, year, month, day, hour, minute, second, nanosecond);
+
+  result= nano_timestamp.is_valid();
+
+  ASSERT_FALSE(result);
+}
+
+TEST_F(NanoTimestampTest, is_valid_InsideOfNanoTimestampRange_shouldReturn_True)
+{
+  uint32_t year= 1980, month= 11, day= 1, hour= 5, minute= 8, second= 5, nanosecond= 3265832;
+  TemporalGenerator::TimestampGen::make_nano_timestamp(&nano_timestamp, year, month, day, hour, minute, second, nanosecond);
+
+  result= nano_timestamp.is_valid();
+
+  ASSERT_TRUE(result);
+}
+
+TEST_F(NanoTimestampTest, to_timespec)
+{
+  struct timespec filled;
+  uint32_t year= 2009, month= 6, day= 3, hour= 4, minute= 59, second= 1, nanosecond= 675;
+  TemporalGenerator::TimestampGen::make_nano_timestamp(&nano_timestamp, year, month, day, hour, minute, second, nanosecond);
+
+  nano_timestamp.to_timespec(&filled);
+
+  EXPECT_EQ(1244005141, filled.tv_sec);
+  EXPECT_EQ(675, filled.tv_nsec);
+}

=== added directory 'unittests/plugin'
=== added file 'unittests/plugin/authentication_test.cc'
--- unittests/plugin/authentication_test.cc	1970-01-01 00:00:00 +0000
+++ unittests/plugin/authentication_test.cc	2010-06-10 20:26:28 +0000
@@ -0,0 +1,132 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+*  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+*
+*  Copyright (C) 2010 Pawel Blokus
+*
+*  This program is free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License as published by
+*  the Free Software Foundation; either version 2 of the License, or
+*  (at your option) any later version.
+*
+*  This program is distributed in the hope that it will be useful,
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*  GNU General Public License for more details.
+*
+*  You should have received a copy of the GNU General Public License
+*  along with this program; if not, write to the Free Software
+*  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+*/
+
+#include "config.h"
+
+#include <drizzled/error.h>
+#include <drizzled/plugin/authentication.h>
+#include <drizzled/security_context.h>
+#include <gtest/gtest.h>
+#include <string>
+
+#include "plugin_stubs.h"
+
+using namespace drizzled;
+
+static void error_handler_func_stub(uint32_t my_err, const char *str, myf MyFlags)
+{
+  (void)my_err;
+  (void)str;
+  (void)MyFlags;
+}
+
+class AuthenticationTest : public ::testing::Test
+{
+public:
+  SecurityContext sctx;
+  std::string passwd;
+  AuthenticationStub stub1;
+  AuthenticationStub stub2;
+
+  AuthenticationTest() :
+    stub1("AuthenticationStub1"),
+    stub2("AuthenticationStub2")
+  {}
+  
+  virtual void SetUp ()
+  {
+    error_handler_hook = error_handler_func_stub;
+  }
+
+  void addOnePlugin()
+  {
+    plugin::Authentication::addPlugin(&stub1);
+  }
+
+  void removeOnePlugin()
+  {
+    plugin::Authentication::removePlugin(&stub1);
+  }
+
+  void addTwoPlugins()
+  {
+    plugin::Authentication::addPlugin(&stub1);
+    plugin::Authentication::addPlugin(&stub2);
+  }
+
+  void removeTwoPlugins()
+  {
+    plugin::Authentication::removePlugin(&stub1);
+    plugin::Authentication::removePlugin(&stub2);
+  }
+  
+};
+
+TEST_F(AuthenticationTest, isAuthenticated_noPluginsLoaded_shouldReturn_True)
+{
+  bool authenticated = plugin::Authentication::isAuthenticated(sctx, passwd);
+
+  ASSERT_TRUE(authenticated);
+}
+
+TEST_F(AuthenticationTest, isAuthenticated_OnePluginReturnigFalse_ShouldReturn_False)
+{
+
+  addOnePlugin();
+  bool authenticated = plugin::Authentication::isAuthenticated(sctx, passwd);
+  removeOnePlugin();
+
+  ASSERT_FALSE(authenticated);
+}
+
+TEST_F(AuthenticationTest, isAuthenticated_OnePluginReturnigTrue_ShouldReturn_True)
+{
+
+  stub1.set_authenticate_return(true);
+  
+  addOnePlugin();
+  bool authenticated = plugin::Authentication::isAuthenticated(sctx, passwd);
+  removeOnePlugin();
+  
+  ASSERT_TRUE(authenticated);
+}
+
+TEST_F(AuthenticationTest, isAuthenticated_TwoPluginsBothReturnigFalse_ShouldReturn_False)
+{
+
+  addTwoPlugins();
+  bool authenticated = plugin::Authentication::isAuthenticated(sctx, passwd);
+  removeTwoPlugins();
+  
+  ASSERT_FALSE(authenticated);
+}
+
+TEST_F(AuthenticationTest, isAuthenticated_TwoPluginsOnlyOneReturnigTrue_ShouldReturn_True)
+{
+  stub2.set_authenticate_return(true);
+  
+  addTwoPlugins();
+  bool authenticated = plugin::Authentication::isAuthenticated(sctx, passwd);
+  removeTwoPlugins();
+  
+  ASSERT_TRUE(authenticated);
+}
+
+

=== added file 'unittests/plugin/client_test.cc'
--- unittests/plugin/client_test.cc	1970-01-01 00:00:00 +0000
+++ unittests/plugin/client_test.cc	2010-06-09 20:36:51 +0000
@@ -0,0 +1,76 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Pawel Blokus
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+ 
+#include "config.h"
+
+#include <drizzled/plugin/client.h>
+#include <drizzled/drizzle_time.h>
+#include <gtest/gtest.h>
+#include <string.h>
+
+#include "plugin_stubs.h"
+
+using namespace drizzled;
+
+class ClientTest : public ::testing::Test
+{
+public:
+  char buffer[40];
+  ClientStub client;
+
+  virtual void SetUp()
+  {
+    memset(buffer, '\0', sizeof(buffer));
+    client.set_store_ret_val(true);
+    client.set_last_call_char_ptr(buffer);
+  }
+};
+
+TEST_F(ClientTest, store_drizzle_time_datetime)
+{
+  //TODO: is the sign intentionally ignored in the case of a datetime?
+  DRIZZLE_TIME dt= { 2010, 4, 5, 23, 45, 3, 777, true, DRIZZLE_TIMESTAMP_DATETIME};
+  char expected[]= "2010-04-05 23:45:03.000777";
+
+  client.store(&dt);
+
+  ASSERT_STREQ(expected, buffer);
+}
+
+TEST_F(ClientTest, store_drizzle_time_date)
+{
+  //TODO: is the sign intentionally ignored in the case of a date?
+  DRIZZLE_TIME dt= { 2010, 4, 5, 0, 0, 0, 0, true, DRIZZLE_TIMESTAMP_DATE};
+  char expected[]= "2010-04-05";
+  
+  client.store(&dt);
+  
+  ASSERT_STREQ(expected, buffer);
+}
+
+TEST_F(ClientTest, store_drizzle_time_time)
+{
+  DRIZZLE_TIME dt= { 2010, 4, 5, 23, 45, 3, 777, true, DRIZZLE_TIMESTAMP_TIME};
+  char expected[]= "-23:45:03.000777";
+  
+  client.store(&dt);
+  
+  ASSERT_STREQ(expected, buffer);
+}

=== added file 'unittests/plugin/error_message_test.cc'
--- unittests/plugin/error_message_test.cc	1970-01-01 00:00:00 +0000
+++ unittests/plugin/error_message_test.cc	2010-06-09 21:37:15 +0000
@@ -0,0 +1,29 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+*  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+*
+*  Copyright (C) 2010 Pawel Blokus
+*
+*  This program is free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License as published by
+*  the Free Software Foundation; either version 2 of the License, or
+*  (at your option) any later version.
+*
+*  This program is distributed in the hope that it will be useful,
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*  GNU General Public License for more details.
+*
+*  You should have received a copy of the GNU General Public License
+*  along with this program; if not, write to the Free Software
+*  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+*/
+
+#include "config.h"
+
+#include <drizzled/plugin/error_message.h>
+#include <gtest/gtest.h>
+
+#include "plugin_stubs.h"
+
+using namespace drizzled;
+

=== added file 'unittests/plugin/plugin_stubs.h'
--- unittests/plugin/plugin_stubs.h	1970-01-01 00:00:00 +0000
+++ unittests/plugin/plugin_stubs.h	2010-06-10 20:26:28 +0000
@@ -0,0 +1,242 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Pawel Blokus
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+
+#ifndef UNITTESTS_STUB_PLUGIN_STUBS_H
+#define UNITTESTS_STUB_PLUGIN_STUBS_H
+ 
+#include "config.h"
+
+#include <cstring>
+#include <drizzled/plugin/authentication.h>
+#include <drizzled/plugin/client.h>
+#include <drizzled/plugin/error_message.h>
+#include <string>
+ 
+class ClientStub : public drizzled::plugin::Client
+{
+protected:
+  bool store_ret_val;
+  char *last_call_char_ptr;
+
+public:
+
+  ClientStub() :
+  store_ret_val(false),
+  last_call_char_ptr(NULL)
+  {}
+
+  inline void set_store_ret_val(bool value)
+  {
+    store_ret_val= value;
+  }
+
+  inline void set_last_call_char_ptr(char *ptr)
+  {
+    last_call_char_ptr= ptr;
+  }
+
+  virtual ~ClientStub() {}
+
+  /**
+  * Get attached session from the client object.
+  * @retval Session object that is attached, NULL if none.
+  */
+  virtual drizzled::Session *getSession(void)
+  {
+    return Client::getSession();
+  }
+
+  /**
+  * Attach session to the client object.
+  * @param[in] session_arg Session object to attach, or NULL to clear.
+  */
+  virtual void setSession(drizzled::Session *session_arg)
+  {
+    Client::setSession(session_arg);
+  }
+
+  /**
+  * Get file descriptor associated with client object.
+  * @retval File descriptor that is attached, -1 if none.
+  */
+  virtual int getFileDescriptor(void) { return 0; };
+
+  /**
+  * Check to see if the client is currently connected.
+  * @retval Boolean value representing connected state.
+  */
+  virtual bool isConnected(void) { return false; };
+
+  /**
+  * Check to see if the client is actively reading.
+  * @retval Boolean value representing reading state.
+  */
+  virtual bool isReading(void) { return false; };
+
+  /**
+  * Check to see if the client is actively writing.
+  * @retval Boolean value representing writing state.
+  */
+  virtual bool isWriting(void)  { return false; };
+
+  /**
+  * Flush all data that has been buffered with store() methods.
+  * @retval Boolean indicating success or failure.
+  */
+  virtual bool flush(void)  { return false; };
+
+  /**
+  * Close the client object.
+  */
+  virtual void close(void) {};
+
+  /**
+  * Perform handshake and authorize client if needed.
+  */
+  virtual bool authenticate(void) { return false; };
+
+  /**
+  * Read command from client.
+  */
+  virtual bool readCommand(char **packet, uint32_t *packet_length)
+  {
+    (void)packet;
+    (void)packet_length;
+    return false;
+  };
+
+  /* Send responses. */
+  virtual void sendOK(void) {};
+  virtual void sendEOF(void) {};
+  virtual void sendError(uint32_t sql_errno, const char *err)
+  {
+    (void)sql_errno;
+    (void)err;
+  };
+
+  /**
+  * Send field list for result set.
+  */
+  virtual bool sendFields(drizzled::List<drizzled::Item> *list)
+  {
+    (void)list;
+    return false;
+  };
+
+  /* Send result fields in various forms. */
+  virtual bool store(drizzled::Field *from)
+  {
+    (void)from;
+    return store_ret_val;
+  };
+  virtual bool store(void) { return store_ret_val; };
+  virtual bool store(int32_t from)
+  {
+    (void)from;
+    return store_ret_val;
+  };
+  virtual bool store(uint32_t from)
+  {
+    (void)from;
+    return store_ret_val;
+  };
+  virtual bool store(int64_t from)
+  {
+    (void)from;
+    return store_ret_val;
+  };
+  virtual bool store(uint64_t from)
+  {
+    (void)from;
+    return store_ret_val;
+  };
+  virtual bool store(double from, uint32_t decimals, drizzled::String *buffer)
+  {
+    (void)from;
+    (void)decimals;
+    (void)buffer;
+    return store_ret_val;
+  };
+  virtual bool store(const drizzled::DRIZZLE_TIME *from)
+  {
+    return Client::store(from);
+  }
+  virtual bool store(const char *from)
+  {
+    return Client::store(from);
+  }
+  virtual bool store(const char *from, size_t length)
+  {
+    strncpy(last_call_char_ptr, from, length);
+    return store_ret_val;
+  };
+  virtual bool store(const std::string &from)
+  {
+    return Client::store(from);
+  }
+
+  /* Try to remove these. */
+  virtual bool haveMoreData(void) { return false; };
+  virtual bool haveError(void) { return false; };
+  virtual bool wasAborted(void) { return false;};
+};
+
+class ErrorMessageStub : public drizzled::plugin::ErrorMessage
+{
+
+public:
+  ErrorMessageStub() : ErrorMessage("ErrorMessageStub") {}
+
+  virtual bool errmsg(drizzled::Session *session, int priority, const char *format, va_list ap)
+  {
+    (void)session;
+    (void)priority;
+    (void)format;
+    (void)ap;
+    return false;
+  }
+};
+
+class AuthenticationStub : public drizzled::plugin::Authentication
+{
+private:
+  bool authenticate_return;
+
+public:
+  AuthenticationStub(std::string name_arg)
+  : Authentication(name_arg),
+    authenticate_return(false)
+  {}
+
+  void set_authenticate_return(bool value)
+  {
+    authenticate_return = value;
+  }
+
+  virtual bool authenticate(const drizzled::SecurityContext &sctx, const std::string &passwd)
+  {
+    (void)sctx;
+    (void)passwd;
+    return authenticate_return;
+  };
+};
+
+#endif /* UNITTESTS_STUB_PLUGIN_STUBS_H */

=== added file 'unittests/temporal_format_test.cc'
--- unittests/temporal_format_test.cc	1970-01-01 00:00:00 +0000
+++ unittests/temporal_format_test.cc	2010-06-09 17:12:30 +0000
@@ -0,0 +1,151 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Pawel Blokus
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <drizzled/temporal.h>
+#include <drizzled/temporal_format.h>
+#include <gtest/gtest.h>
+#include <vector>
+
+#include "temporal_generator.h"
+
+using namespace drizzled;
+
+class TemporalFormatTest : public ::testing::Test
+{
+  protected:
+    TemporalFormat *tf;
+    Temporal *temporal;
+    bool result;
+
+  virtual void SetUp()
+  {
+    tf= NULL;
+    temporal= NULL;
+  }
+
+  virtual void TearDown()
+  {
+    if (tf != NULL)
+      delete tf;
+    if (temporal != NULL)
+      delete temporal;
+  }
+};
+
+
+TEST_F(TemporalFormatTest, constructor_WithValidRegExp_shouldCompile)
+{
+  tf= new TemporalFormat("^(\\d{4})[-/.]$");
+  
+  result= tf->is_valid();
+
+  ASSERT_TRUE(result);
+}
+
+TEST_F(TemporalFormatTest, constructor_WithInvalidRegExp_shouldNotCompile)
+{
+  tf= new TemporalFormat("^\\d{4)[-/.]$");
+
+  result= tf->is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(TemporalFormatTest, matches_OnNotMatchingString_shouldReturn_False)
+{
+  tf= new TemporalFormat("^(\\d{4})[-/.]$");
+  char matched[] ="1234/ABC";
+
+  result= tf->matches(matched, sizeof(matched) - sizeof(char), NULL);
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(TemporalFormatTest, matches_OnMatchingString_FormatWithIndexesSet_shouldPopulateTemporal)
+{
+  char regexp[]= "^(\\d{4})[-/.](\\d{1,2})[-/.](\\d{1,2})[T|\\s+](\\d{2}):(\\d{2}):(\\d{2})$";
+  char matched[]= "1999/9/14T23:29:05";
+  tf= TemporalGenerator::TemporalFormatGen::make_temporal_format(regexp, 1, 2, 3, 4, 5, 6, 0, 0);
+  temporal= new DateTime();
+
+  
+  result= tf->matches(matched, sizeof(matched) - sizeof(char), temporal);
+  ASSERT_TRUE(result);
+  
+  EXPECT_EQ(1999, temporal->years());
+  EXPECT_EQ(9, temporal->months());
+  EXPECT_EQ(14, temporal->days());
+  EXPECT_EQ(23, temporal->hours());
+  EXPECT_EQ(29, temporal->minutes());
+  EXPECT_EQ(5, temporal->seconds());
+}
+
+TEST_F(TemporalFormatTest, matches_FormatWithMicroSecondIndexSet_shouldAddTrailingZeros)
+{
+  tf= TemporalGenerator::TemporalFormatGen::make_temporal_format("^(\\d{1,6})$", 0, 0, 0, 0, 0, 0, 1, 0);
+  char matched[]= "560";
+  temporal= new Time();
+  
+  tf->matches(matched, sizeof(matched) - sizeof(char), temporal);
+  
+  ASSERT_EQ(560000, temporal->useconds());
+}
+
+TEST_F(TemporalFormatTest, matches_FormatWithNanoSecondIndexSet_shouldAddTrailingZeros)
+{
+  tf= TemporalGenerator::TemporalFormatGen::make_temporal_format("^(\\d{1,9})$", 0, 0, 0, 0, 0, 0, 0, 1);
+  char matched[]= "4321";
+  temporal= new Time();
+  
+  tf->matches(matched, sizeof(matched) - sizeof(char), temporal);
+  
+  ASSERT_EQ(432100000, temporal->nseconds());
+}
+
+namespace drizzled
+{
+extern std::vector<TemporalFormat *> known_datetime_formats;
+extern std::vector<TemporalFormat *> known_date_formats;
+extern std::vector<TemporalFormat *> known_time_formats;
+extern std::vector<TemporalFormat *> all_temporal_formats;
+}
+
+TEST(TemporalFormatInitTest, init_temporal_formats_vectorsWithKnownFormats_shouldHaveExpectedLengths)
+{
+  init_temporal_formats();
+
+  EXPECT_EQ(13, known_datetime_formats.size());	
+  EXPECT_EQ(8, known_date_formats.size());
+  EXPECT_EQ(6, known_time_formats.size());
+  EXPECT_EQ(19, all_temporal_formats.size());
+}
+
+TEST(TemporalFormatDeinitTest, deinit_temporal_formats_vectorsWithKnownFormats_shouldHaveZeroLengths)
+{
+  init_temporal_formats();
+  deinit_temporal_formats();
+  
+  EXPECT_EQ(0, known_datetime_formats.size());
+  EXPECT_EQ(0, known_date_formats.size());
+  EXPECT_EQ(0, known_time_formats.size());
+  EXPECT_EQ(0, all_temporal_formats.size());
+}

=== added file 'unittests/temporal_generator.cc'
--- unittests/temporal_generator.cc	1970-01-01 00:00:00 +0000
+++ unittests/temporal_generator.cc	2010-06-09 17:12:30 +0000
@@ -0,0 +1,195 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Pawel Blokus
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <drizzled/temporal.h>
+#include <drizzled/temporal_format.h>
+#include <drizzled/temporal_interval.h>
+
+#include "temporal_generator.h"
+
+using namespace drizzled;
+
+void TemporalGenerator::DateGen::make_date(Date *date,
+                                          uint32_t years, uint32_t months, uint32_t days)
+{
+  date->set_years(years);
+  date->set_months(months);
+  date->set_days(days);
+  date->set_epoch_seconds();
+}
+
+void TemporalGenerator::DateGen::make_valid_date(drizzled::Date *date)
+{
+  date->set_years(2005);
+  date->set_months(5);
+  date->set_days(26);
+  date->set_epoch_seconds();
+}
+
+void TemporalGenerator::TemporalGen::leap_day_in_leap_year(drizzled::Temporal *temporal)
+{
+  temporal->set_years(2008);
+  temporal->set_months(2);
+  temporal->set_days(29);
+  temporal->set_epoch_seconds();
+}
+
+void TemporalGenerator::TemporalGen::leap_day_in_non_leap_year(drizzled::Temporal *temporal)
+{
+  temporal->set_years(2010);
+  temporal->set_months(2);
+  temporal->set_days(29);
+  temporal->set_epoch_seconds();
+}
+
+void TemporalGenerator::TimeGen::make_time(drizzled::Time *time,
+                                   uint32_t hours, uint32_t minutes, uint32_t seconds,
+                                   uint32_t useconds)
+{
+  time->set_hours(hours);
+  time->set_minutes(minutes);
+  time->set_seconds(seconds);
+  time->set_useconds(useconds);
+  time->set_epoch_seconds();
+}
+
+void TemporalGenerator::TemporalGen::make_min_time(drizzled::Temporal *temporal)
+{
+  temporal->set_hours(0);
+  temporal->set_minutes(0);
+  temporal->set_seconds(0);
+  temporal->set_epoch_seconds();
+}
+
+void TemporalGenerator::TemporalGen::make_max_time(drizzled::Temporal *temporal)
+{
+  temporal->set_hours(23);
+  temporal->set_minutes(59);
+  temporal->set_seconds(59);
+  temporal->set_epoch_seconds();
+}
+
+void TemporalGenerator::DateTimeGen::make_datetime(drizzled::DateTime *datetime,
+                   uint32_t years, uint32_t months, uint32_t days, uint32_t hours,
+                   uint32_t minutes, uint32_t seconds, uint32_t useconds)
+{
+  datetime->set_years(years);
+  datetime->set_months(months);
+  datetime->set_days(days);
+  datetime->set_hours(hours);
+  datetime->set_minutes(minutes);
+  datetime->set_seconds(seconds);
+  datetime->set_useconds(useconds);
+  datetime->set_epoch_seconds();
+}                     
+
+void TemporalGenerator::DateTimeGen::make_valid_datetime(drizzled::DateTime *datetime)
+{
+  datetime->set_years(1999);
+  datetime->set_months(8);
+  datetime->set_days(15);
+  datetime->set_hours(13);
+  datetime->set_minutes(34);
+  datetime->set_seconds(6);
+  datetime->set_epoch_seconds();
+}
+
+void TemporalGenerator::TimestampGen::make_timestamp(drizzled::Timestamp *timestamp,
+                                             uint32_t years, uint32_t months, uint32_t days,
+                                             uint32_t hours, uint32_t minutes, uint32_t seconds)
+{
+  timestamp->set_years(years);
+  timestamp->set_months(months);
+  timestamp->set_days(days);
+  timestamp->set_hours(hours);
+  timestamp->set_minutes(minutes);
+  timestamp->set_seconds(seconds);
+  timestamp->set_epoch_seconds();
+}
+
+void TemporalGenerator::TimestampGen::make_micro_timestamp(drizzled::MicroTimestamp *timestamp,
+                                                   uint32_t years, uint32_t months, uint32_t days,
+                                                   uint32_t hours, uint32_t minutes,
+                                                   uint32_t seconds, uint32_t microseconds)
+{
+  make_timestamp(timestamp, years, months, days, hours, minutes, seconds);
+  timestamp->set_useconds(microseconds);
+  timestamp->set_epoch_seconds();
+}
+                                 
+void TemporalGenerator::TimestampGen::make_nano_timestamp(drizzled::NanoTimestamp *timestamp,
+                                                  uint32_t years, uint32_t months, uint32_t days,
+                                                  uint32_t hours, uint32_t minutes,
+                                                  uint32_t seconds, uint32_t nanoseconds)
+{
+  make_timestamp(timestamp, years, months, days, hours, minutes, seconds);
+  timestamp->set_nseconds(nanoseconds);
+  timestamp->set_epoch_seconds();
+}
+
+drizzled::TemporalFormat *TemporalGenerator::TemporalFormatGen::make_temporal_format(const char *regexp,
+                                                                  int32_t year_part_index,
+                                                                  int32_t month_part_index,
+                                                                  int32_t day_part_index,
+                                                                  int32_t hour_part_index,
+                                                                  int32_t minute_part_index,
+                                                                  int32_t second_part_index,
+                                                                  int32_t usecond_part_index,
+                                                                  int32_t nsecond_part_index)
+{
+  drizzled::TemporalFormat *temporal_format= new drizzled::TemporalFormat(regexp);
+  
+  temporal_format->set_year_part_index(year_part_index);
+  temporal_format->set_month_part_index(month_part_index);
+  temporal_format->set_day_part_index(day_part_index);
+  temporal_format->set_hour_part_index(hour_part_index);
+  temporal_format->set_minute_part_index(minute_part_index);
+  temporal_format->set_second_part_index(second_part_index);
+  temporal_format->set_usecond_part_index(usecond_part_index);
+  temporal_format->set_nsecond_part_index(nsecond_part_index);
+
+  return temporal_format;
+}
+
+drizzled::TemporalInterval *TemporalGenerator::TemporalIntervalGen::make_temporal_interval(
+                                                              uint32_t  year,
+                                                              uint32_t  month,
+                                                              uint32_t  day,
+                                                              uint32_t  hour,
+                                                              uint64_t  minute,
+                                                              uint64_t  second,
+                                                              uint64_t  second_part,
+                                                              bool neg)
+{
+  drizzled::TemporalInterval *interval= new drizzled::TemporalInterval();
+
+  interval->set_year(year);
+  interval->set_month(month);
+  interval->set_day(day);
+  interval->set_hour(hour);
+  interval->set_minute(minute);
+  interval->set_second(second);
+  interval->set_second_part(second_part);
+  interval->setNegative(neg);
+
+  return interval;
+}

=== added file 'unittests/temporal_generator.h'
--- unittests/temporal_generator.h	1970-01-01 00:00:00 +0000
+++ unittests/temporal_generator.h	2010-06-09 16:53:31 +0000
@@ -0,0 +1,117 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Pawel Blokus
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#ifndef UNITTESTS_GENERATOR_H
+#define UNITTESTS_GENERATOR_H
+
+#include "config.h"
+
+namespace drizzled
+{
+  class Date;
+  class TemporalFormat;
+  class Temporal;
+  class Time;
+  class DateTime;
+  class Timestamp;
+  class MicroTimestamp;
+  class NanoTimestamp;
+}
+
+class TemporalGenerator 
+{
+public:
+
+  class TemporalGen
+  {
+  public:
+    static void leap_day_in_leap_year(drizzled::Temporal *temporal);
+    static void leap_day_in_non_leap_year(drizzled::Temporal *temporal);
+    static void make_min_time(drizzled::Temporal *temporal);
+    static void make_max_time(drizzled::Temporal *temporal);
+  };
+  
+  class DateGen
+  {
+  public:
+    static void make_date(drizzled::Date *date, uint32_t years, uint32_t months, uint32_t days);
+    static void make_valid_date(drizzled::Date *date);  
+  };
+  
+  class TimeGen
+  {
+  public:
+    static void make_time(drizzled::Time *time, uint32_t hours, uint32_t minutes, uint32_t seconds,
+                          uint32_t useconds = 0);
+  };
+  
+  class DateTimeGen
+  {
+  public:
+    static void make_datetime(drizzled::DateTime *datetime,
+                              uint32_t years, uint32_t months, uint32_t days, uint32_t hours,
+                              uint32_t minutes, uint32_t seconds, uint32_t useconds = 0);
+    static void make_valid_datetime(drizzled::DateTime *datetime);
+  };
+  
+  class TimestampGen
+  {
+  public:
+    static void make_timestamp(drizzled::Timestamp *timestamp,
+                               uint32_t years, uint32_t months, uint32_t days, uint32_t hours,
+                               uint32_t minutes, uint32_t seconds);
+    static void make_micro_timestamp(drizzled::MicroTimestamp *timestamp,
+                              uint32_t years, uint32_t months, uint32_t days, uint32_t hours,
+                              uint32_t minutes, uint32_t seconds, uint32_t microseconds);
+    static void make_nano_timestamp(drizzled::NanoTimestamp *timestamp,
+                                uint32_t years, uint32_t months, uint32_t days, uint32_t hours,
+                                uint32_t minutes, uint32_t seconds, uint32_t nanoseconds);
+  };
+
+  class TemporalFormatGen
+  {
+  public:
+    static drizzled::TemporalFormat *make_temporal_format(const char *regexp,
+                                     int32_t year_part_index,
+                                     int32_t month_part_index,
+                                     int32_t day_part_index,
+                                     int32_t hour_part_index,
+                                     int32_t minute_part_index,
+                                     int32_t second_part_index,
+                                     int32_t usecond_part_index,
+                                     int32_t nsecond_part_index);
+  };
+
+  class TemporalIntervalGen
+  {
+  public:
+    static drizzled::TemporalInterval *make_temporal_interval(
+                                                              uint32_t  year,
+                                                              uint32_t  month,
+                                                              uint32_t  day,
+                                                              uint32_t  hour,
+                                                              uint64_t  minute,
+                                                              uint64_t  second,
+                                                              uint64_t  second_part,
+                                                              bool neg);
+  };
+};
+
+#endif /*UNITTESTS_GENERATOR_H*/
\ No newline at end of file

=== added file 'unittests/temporal_interval_test.cc'
--- unittests/temporal_interval_test.cc	1970-01-01 00:00:00 +0000
+++ unittests/temporal_interval_test.cc	2010-06-09 17:12:30 +0000
@@ -0,0 +1,228 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Pawel Blokus
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <boost/shared_ptr.hpp>
+
+#include <cstdlib>
+#include <gtest/gtest.h>
+#include <drizzled/item.h>
+#include <drizzled/session.h>
+#include <drizzled/sql_string.h>
+#include <drizzled/temporal_interval.h>
+#include <drizzled/plugin/listen.h>
+
+#include "temporal_generator.h"
+
+using namespace drizzled;
+
+class ItemStub : public Item
+{
+  ItemStub(Session *fake_session) : Item(fake_session, this)
+  {
+    string_to_return= NULL;
+    int_to_return= 0;
+  }
+  
+  public:
+    String *string_to_return;
+    int int_to_return;
+    
+    static boost::shared_ptr<ItemStub> get_item_stub(Session *fake_session)
+    {
+      boost::shared_ptr<ItemStub> result(new ItemStub(fake_session));
+      return result;
+    }
+    
+    virtual enum Type type() const { return FIELD_ITEM; };
+    virtual double val_real() { return 0; };
+    virtual int64_t val_int() { return int_to_return; };
+    virtual String *val_str(String *str)
+    {
+      (void) str;
+      return string_to_return;
+    };
+    virtual my_decimal *val_decimal(my_decimal *decimal_buffer)
+    {
+      (void) decimal_buffer;
+      return NULL;
+    };
+};
+
+class TemporalIntervalTest : public ::testing::Test
+{
+  protected:
+    String string_to_return;
+    String buffer;
+    bool result;
+    boost::shared_ptr<ItemStub> item;
+    TemporalInterval interval;
+    Session *fake_session;
+
+    plugin::Client *fake_client;
+    
+    virtual void SetUp()
+    {
+      fake_client= plugin::Listen::getNullClient();
+      fake_session= new Session(fake_client);
+      fake_session->thread_stack= (char*) &fake_session;
+      fake_session->initGlobals();
+      item= ItemStub::get_item_stub(fake_session);
+
+
+      /*28 for full date and time format with sign*/
+      string_to_return.alloc(28);
+      buffer.alloc(28);
+      item->string_to_return= &string_to_return;
+      item->int_to_return= 0;
+      item->null_value= false;
+    }
+};
+
+TEST_F(TemporalIntervalTest, initFromItem_intervalWeek)
+{
+  char string[]= "30";
+  item->string_to_return->set_ascii(string, strlen(string));
+  item->int_to_return= 30;
+
+  interval.initFromItem(item.get(), INTERVAL_WEEK, &buffer);
+
+  ASSERT_EQ(210, interval.get_day());
+}
+
+TEST_F(TemporalIntervalTest, initFromItem_intervalDayMicrosecond)
+{
+  char string[]= "7 12:45:19.777";
+  item->string_to_return->set_ascii(string, strlen(string));
+
+  interval.initFromItem(item.get(), INTERVAL_DAY_MICROSECOND, &buffer);
+
+  EXPECT_EQ(7, interval.get_day());
+  EXPECT_EQ(12, interval.get_hour());
+  EXPECT_EQ(45, interval.get_minute());
+  EXPECT_EQ(19, interval.get_second());
+  EXPECT_EQ(777000, interval.get_second_part());
+}
+
+TEST_F(TemporalIntervalTest, initFromItem_intervalDayMicrosecond_tooFewArguments_shouldOmitHighEndItems)
+{
+  char string[]= "45:19.777";
+  item->string_to_return->set_ascii(string, strlen(string));
+  
+  interval.initFromItem(item.get(), INTERVAL_DAY_MICROSECOND, &buffer);
+  
+  EXPECT_EQ(0, interval.get_day());
+  EXPECT_EQ(0, interval.get_hour());
+  EXPECT_EQ(45, interval.get_minute());
+  EXPECT_EQ(19, interval.get_second());
+  EXPECT_EQ(777000, interval.get_second_part());
+}
+
+
+TEST(TemporalIntervalAddDateTest, addDate_positiveDayMicrosecond)
+{
+  DRIZZLE_TIME drizzle_time= {1990, 3, 25, 15, 5, 16, 876543, false, DRIZZLE_TIMESTAMP_DATETIME};
+  TemporalInterval *interval= TemporalGenerator::TemporalIntervalGen::make_temporal_interval(
+                               0, 0, 6, 13, 54, 3, 435675, false);
+
+  interval->addDate(&drizzle_time, INTERVAL_DAY_MICROSECOND);
+
+  EXPECT_EQ(1990, drizzle_time.year);
+  EXPECT_EQ(4, drizzle_time.month);
+  EXPECT_EQ(1, drizzle_time.day);
+  EXPECT_EQ(4, drizzle_time.hour);
+  EXPECT_EQ(59, drizzle_time.minute);
+  EXPECT_EQ(20, drizzle_time.second);
+  EXPECT_EQ(312218, drizzle_time.second_part);
+}
+
+TEST(TemporalIntervalAddDateTest, addDate_negativeDayMicrosecond)
+{
+  DRIZZLE_TIME drizzle_time= {1990, 4, 1, 4, 59, 20, 312218, false, DRIZZLE_TIMESTAMP_DATETIME};
+  TemporalInterval *interval= TemporalGenerator::TemporalIntervalGen::make_temporal_interval(
+                               0, 0, 6, 13, 54, 3, 435675, true);
+  
+  interval->addDate(&drizzle_time, INTERVAL_DAY_MICROSECOND);
+  
+  EXPECT_EQ(1990, drizzle_time.year);
+  EXPECT_EQ(3, drizzle_time.month);
+  EXPECT_EQ(25, drizzle_time.day);
+  EXPECT_EQ(15, drizzle_time.hour);
+  EXPECT_EQ(5, drizzle_time.minute);
+  EXPECT_EQ(16, drizzle_time.second);
+  EXPECT_EQ(876543, drizzle_time.second_part);
+}
+
+TEST(TemporalIntervalAddDateTest, addDate_positiveDayMicrosecond_shouldCountLeapDayToo)
+{
+  DRIZZLE_TIME drizzle_time= {2004, 2, 25, 15, 5, 16, 876543, false, DRIZZLE_TIMESTAMP_DATETIME};
+  TemporalInterval *interval= TemporalGenerator::TemporalIntervalGen::make_temporal_interval(
+                               0, 0, 6, 13, 54, 3, 435675, false);
+  
+  interval->addDate(&drizzle_time, INTERVAL_DAY_MICROSECOND);
+  
+  EXPECT_EQ(2004, drizzle_time.year);
+  EXPECT_EQ(3, drizzle_time.month);
+  EXPECT_EQ(3, drizzle_time.day);
+  EXPECT_EQ(4, drizzle_time.hour);
+  EXPECT_EQ(59, drizzle_time.minute);
+  EXPECT_EQ(20, drizzle_time.second);
+  EXPECT_EQ(312218, drizzle_time.second_part);
+}
+
+TEST(TemporalIntervalAddDateTest, addDate_negativeWeek)
+{
+  DRIZZLE_TIME drizzle_time= {1998, 1, 25, 0, 0, 0, 0, false, DRIZZLE_TIMESTAMP_DATE};
+  TemporalInterval *interval= TemporalGenerator::TemporalIntervalGen::make_temporal_interval(
+                              0, 0, 28, 0, 0, 0, 0, true);
+  
+  interval->addDate(&drizzle_time, INTERVAL_WEEK);
+  
+  EXPECT_EQ(1997, drizzle_time.year);
+  EXPECT_EQ(12, drizzle_time.month);
+  EXPECT_EQ(28, drizzle_time.day);
+}
+
+TEST(TemporalIntervalAddDateTest, addDate_addPositiveYearToLeapDay)
+{
+  DRIZZLE_TIME drizzle_time= {2004, 2, 29, 0, 0, 0, 0, false, DRIZZLE_TIMESTAMP_DATE};
+  TemporalInterval *interval= TemporalGenerator::TemporalIntervalGen::make_temporal_interval(
+                               5, 0, 0, 0, 0, 0, 0, false);
+  
+  interval->addDate(&drizzle_time, INTERVAL_YEAR);
+  
+  EXPECT_EQ(2009, drizzle_time.year);
+  EXPECT_EQ(2, drizzle_time.month);
+  EXPECT_EQ(28, drizzle_time.day);
+}
+
+TEST(TemporalIntervalAddDateTest, addDate_addOneMonthToLastDayInMonth_shouldChangeToProperLastDay)
+{
+  DRIZZLE_TIME drizzle_time= {2004, 7, 31, 0, 0, 0, 0, false, DRIZZLE_TIMESTAMP_DATE};
+  TemporalInterval *interval= TemporalGenerator::TemporalIntervalGen::make_temporal_interval(
+                               0, 2, 0, 0, 0, 0, 0, false);
+  
+  interval->addDate(&drizzle_time, INTERVAL_MONTH);
+  
+  EXPECT_EQ(2004, drizzle_time.year);
+  EXPECT_EQ(9, drizzle_time.month);
+  EXPECT_EQ(30, drizzle_time.day);
+}

=== added file 'unittests/time_test.cc'
--- unittests/time_test.cc	1970-01-01 00:00:00 +0000
+++ unittests/time_test.cc	2010-06-09 17:12:30 +0000
@@ -0,0 +1,381 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+*  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+*
+*  Copyright (C) 2010 Pawel Blokus
+*
+*  This program is free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License as published by
+*  the Free Software Foundation; either version 2 of the License, or
+*  (at your option) any later version.
+*
+*  This program is distributed in the hope that it will be useful,
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*  GNU General Public License for more details.
+*
+*  You should have received a copy of the GNU General Public License
+*  along with this program; if not, write to the Free Software
+*  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+*/
+
+#include "config.h"
+
+#include <gtest/gtest.h>
+#include <drizzled/decimal.h>
+#include <drizzled/temporal.h>
+#include <drizzled/temporal_format.h>
+
+#include "temporal_generator.h"
+
+using namespace drizzled;
+
+class TimeTest: public ::testing::Test
+{
+protected:
+  Time sample_time;
+  bool result;
+  uint32_t hours, minutes, seconds;
+  
+  Time identical_with_sample_time, before_sample_time, after_sample_time;
+  
+  virtual void SetUp()
+  {
+    TemporalGenerator::TimeGen::make_time(&sample_time, 18, 34, 59);
+    
+    TemporalGenerator::TimeGen::make_time(&before_sample_time, 18, 34, 58);
+    TemporalGenerator::TimeGen::make_time(&identical_with_sample_time, 18, 34, 59);
+    TemporalGenerator::TimeGen::make_time(&after_sample_time, 18, 35, 0);
+    
+  }
+
+  void assign_time_values()
+  {
+    hours= sample_time.hours();
+    minutes= sample_time.minutes();
+    seconds= sample_time.seconds();
+  }
+
+  void from_string(const char *string)
+  {
+    
+    init_temporal_formats();
+    result= sample_time.from_string(string, strlen(string));
+    deinit_temporal_formats();
+    
+    assign_time_values();
+  }
+};
+
+TEST_F(TimeTest, operatorEqual_ComparingWithIdencticalTime_ShouldReturn_True)
+{
+  this->result= (this->sample_time == this->identical_with_sample_time);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TEST_F(TimeTest, operatorEqual_ComparingWithDifferentTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_time == this->before_sample_time);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TEST_F(TimeTest, operatorNotEqual_ComparingWithIdencticalTemporal_ShouldReturn_False)
+{ 
+  this->result= (this->sample_time != this->identical_with_sample_time);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TEST_F(TimeTest, operatorNotEqual_ComparingWithDifferentTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_time != this->before_sample_time);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TEST_F(TimeTest, operatorGreaterThan_ComparingWithIdenticalTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_time > this->identical_with_sample_time);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TEST_F(TimeTest, operatorGreaterThan_ComparingWithLaterTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_time > this->after_sample_time);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TEST_F(TimeTest, operatorGreaterThan_ComparingWithEarlierTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_time > this->before_sample_time);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TEST_F(TimeTest, operatorGreaterThanOrEqual_ComparingWithIdenticalTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_time >= this->identical_with_sample_time);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TEST_F(TimeTest, operatorGreaterThanOrEqual_ComparingWithLaterTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_time >= this->after_sample_time);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TEST_F(TimeTest, operatorGreaterThanOrEqual_ComparingWithEarlierTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_time >= this->before_sample_time);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TEST_F(TimeTest, operatorLessThan_ComparingWithIdenticalTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_time < this->identical_with_sample_time);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TEST_F(TimeTest, operatorLessThan_ComparingWithLaterTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_time < this->after_sample_time);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TEST_F(TimeTest, operatorLessThan_ComparingWithEarlierTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_time < this->before_sample_time);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TEST_F(TimeTest, operatorLessThanOrEqual_ComparingWithIdenticalTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_time <= this->identical_with_sample_time);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TEST_F(TimeTest, operatorLessThanOrEqual_ComparingWithLaterTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_time <= this->after_sample_time);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TEST_F(TimeTest, operatorLessThanOrEqual_ComparingWithEarlierTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_time <= this->before_sample_time);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TEST_F(TimeTest, is_valid_onValidTime_shouldReturn_True)
+{
+  result= sample_time.is_valid();
+  
+  ASSERT_TRUE(result);
+}
+
+TEST_F(TimeTest, is_valid_onValidMinimalTime_shouldReturn_True)
+{
+  TemporalGenerator::TemporalGen::make_min_time(&sample_time);
+  
+  result= sample_time.is_valid();
+  
+  ASSERT_TRUE(result);
+}
+
+TEST_F(TimeTest, is_valid_onValidMaximalTime_shouldReturn_True)
+{
+  TemporalGenerator::TemporalGen::make_max_time(&sample_time);
+  
+  result= sample_time.is_valid();
+  
+  ASSERT_TRUE(result);
+}
+
+TEST_F(TimeTest, is_valid_onInvalidTimeWithHourAboveMaximum23_shouldReturn_False)
+{
+  sample_time.set_hours(24);
+  
+  result= sample_time.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(TimeTest, is_valid_onInvalidTimeWithMinutesAboveMaximum59_shouldReturn_False)
+{
+  sample_time.set_minutes(60);
+  
+  result= sample_time.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(TimeTest, is_valid_onInvalidTimeWithSecondsAboveMaximum59_shouldReturn_False)
+{
+  sample_time.set_seconds(60);
+  
+  result= sample_time.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(TimeTest, to_string_shouldProduce_colonSeperatedTimeElements)
+{
+  char expected[Time::MAX_STRING_LENGTH]= "18:34:59";
+  char returned[Time::MAX_STRING_LENGTH];
+  
+  sample_time.to_string(returned, Time::MAX_STRING_LENGTH);
+  
+  ASSERT_STREQ(expected, returned);  
+}
+
+TEST_F(TimeTest, to_string_nullBuffer_shouldReturnProperLengthAnyway)
+{
+  int length= sample_time.to_string(NULL, 0);
+  
+  ASSERT_EQ(Time::MAX_STRING_LENGTH - 1, length);  
+}
+
+TEST_F(TimeTest, to_int32_t)
+{
+  int32_t representation;
+
+  sample_time.to_int32_t(&representation);
+
+  ASSERT_EQ(representation, 183459);
+}
+
+TEST_F(TimeTest, from_int32_t_shouldPopulateTimeCorrectly)
+{
+  sample_time.from_int32_t(183459);
+  
+  assign_time_values();;
+  
+  EXPECT_EQ(18, hours);
+  EXPECT_EQ(34, minutes);
+  EXPECT_EQ(59, seconds);
+}
+
+TEST_F(TimeTest, from_time_t)
+{
+  sample_time.from_time_t(59588);
+  
+  assign_time_values();
+  
+  EXPECT_EQ(16, hours);  
+  EXPECT_EQ(33, minutes);
+  EXPECT_EQ(8, seconds);
+}
+
+TEST_F(TimeTest, to_decimal)
+{
+  drizzled::my_decimal to;
+  TemporalGenerator::TimeGen::make_time(&sample_time, 8, 4, 9, 56);
+
+  sample_time.to_decimal(&to);
+  
+  ASSERT_EQ(80409, to.buf[0]);
+  ASSERT_EQ(56000, to.buf[1]);
+}
+
+TEST_F(TimeTest, from_string_invalidString_shouldReturn_False)
+{
+  char invalid_string[Time::MAX_STRING_LENGTH]= "1o:34:59";
+  
+  init_temporal_formats();
+  result= sample_time.from_string(invalid_string, strlen(invalid_string));
+  deinit_temporal_formats();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(TimeTest, from_string_validString_minuteAndSecond_shouldPopulateCorrectly)
+{
+  char valid_string[Time::MAX_STRING_LENGTH]= "4:52";
+
+  from_string(valid_string);
+
+  EXPECT_EQ(4, minutes);
+  EXPECT_EQ(52, seconds);
+}
+
+TEST_F(TimeTest, from_string_validString_minuteAndSecondNoColon_shouldPopulateCorrectly)
+{
+  char valid_string[Time::MAX_STRING_LENGTH]= "3456";
+  
+  from_string(valid_string);
+  
+  EXPECT_EQ(34, minutes);
+  EXPECT_EQ(56, seconds);
+}
+
+TEST_F(TimeTest, from_string_validString_secondsOnly_shouldPopulateCorrectly)
+{
+  char valid_string[Time::MAX_STRING_LENGTH]= "59";
+  
+  from_string(valid_string);
+  
+  EXPECT_EQ(59, seconds);
+}
+
+class TimeFromStringTest: public ::testing::TestWithParam<const char*>
+{
+  protected:
+    Time time;
+    bool result;
+    uint32_t hours, minutes, seconds;
+    
+    virtual void SetUp()
+    {
+      init_temporal_formats();
+    }
+    
+    virtual void TearDown()
+    {
+      deinit_temporal_formats();
+    }
+    
+    void assign_time_values()
+    {
+      hours= time.hours();
+      minutes= time.minutes();
+      seconds= time.seconds();
+    }
+};
+
+TEST_P(TimeFromStringTest, from_string)
+{
+  const char *valid_string= GetParam();
+
+  result= time.from_string(valid_string, strlen(valid_string));
+  ASSERT_TRUE(result);
+  
+  assign_time_values();
+
+  EXPECT_EQ(8, hours);
+  EXPECT_EQ(4, minutes);
+  EXPECT_EQ(9, seconds);
+}
+
+/* TODO:for some reason this was not declared by the macro, needs clarification*/
+testing::internal::ParamGenerator<const char*> gtest_ValidStringTimeFromStringTest_EvalGenerator_();
+
+INSTANTIATE_TEST_CASE_P(ValidString, TimeFromStringTest,
+                        ::testing::Values("080409",
+                                          "80409",
+                                          "08:04:09",
+                                          "8:04:09",
+                                          "8:04:9",
+                                          "8:4:9"));
+                                          
\ No newline at end of file

=== added file 'unittests/timestamp_test.cc'
--- unittests/timestamp_test.cc	1970-01-01 00:00:00 +0000
+++ unittests/timestamp_test.cc	2010-06-09 17:12:30 +0000
@@ -0,0 +1,262 @@
+/* -*- mode: c; c-basic-offset: 2; indent-tabs-mode: nil; -*-
+ *  vim:expandtab:shiftwidth=2:tabstop=2:smarttab:
+ *
+ *  Copyright (C) 2010 Pawel Blokus
+ *
+ *  This program is free software; you can redistribute it and/or modify
+ *  it under the terms of the GNU General Public License as published by
+ *  the Free Software Foundation; either version 2 of the License, or
+ *  (at your option) any later version.
+ *
+ *  This program is distributed in the hope that it will be useful,
+ *  but WITHOUT ANY WARRANTY; without even the implied warranty of
+ *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ *  GNU General Public License for more details.
+ *
+ *  You should have received a copy of the GNU General Public License
+ *  along with this program; if not, write to the Free Software
+ *  Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+ */
+
+#include "config.h"
+
+#include <gtest/gtest.h>
+#include <drizzled/temporal.h>
+
+#include "temporal_generator.h"
+
+using namespace drizzled;
+
+template <typename TemporalType>
+class TimestampTestCompareOperators : public ::testing::Test
+{
+ protected:
+  Timestamp sample_timestamp;
+  bool result;
+  
+  TemporalType identical_with_sample_timestamp, before_sample_timestamp, after_sample_timestamp;
+  
+  void initBeforeIdenticalAfter();
+
+  virtual void SetUp()
+  {
+    TemporalGenerator::TimestampGen::make_timestamp(&sample_timestamp, 2010, 9, 8, 0, 0, 0);
+    initBeforeIdenticalAfter();
+  }
+};
+
+template<> void TimestampTestCompareOperators<Date>::initBeforeIdenticalAfter()
+{
+  TemporalGenerator::DateGen::make_date(&before_sample_timestamp, 1980, 1, 1);
+  TemporalGenerator::DateGen::make_date(&identical_with_sample_timestamp, 2010, 9, 8);
+  TemporalGenerator::DateGen::make_date(&after_sample_timestamp, 2019, 5, 30);
+}
+
+template<> void TimestampTestCompareOperators<DateTime>::initBeforeIdenticalAfter()
+{
+  TemporalGenerator::DateTimeGen::make_datetime(&before_sample_timestamp, 1990, 12, 31, 12, 12, 30);
+  TemporalGenerator::DateTimeGen::make_datetime(&identical_with_sample_timestamp, 2010, 9, 8, 0, 0, 0);
+  TemporalGenerator::DateTimeGen::make_datetime(&after_sample_timestamp, 2020, 4, 4, 4, 4, 4);
+}
+
+template<> void TimestampTestCompareOperators<Timestamp>::initBeforeIdenticalAfter()
+{
+  TemporalGenerator::TimestampGen::make_timestamp(&before_sample_timestamp, 2010, 9, 7, 23, 59, 59);
+  TemporalGenerator::TimestampGen::make_timestamp(&identical_with_sample_timestamp, 2010, 9, 8, 0, 0, 0);
+  TemporalGenerator::TimestampGen::make_timestamp(&after_sample_timestamp, 2010, 9, 8, 0, 0, 1);
+}
+
+typedef ::testing::Types<Date, DateTime, Timestamp> typesForTimestampTestCompareOperators;
+TYPED_TEST_CASE(TimestampTestCompareOperators, typesForTimestampTestCompareOperators);
+
+TYPED_TEST(TimestampTestCompareOperators, operatorEqual_ComparingWithIdencticalTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_timestamp == this->identical_with_sample_timestamp);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TYPED_TEST(TimestampTestCompareOperators, operatorEqual_ComparingWithDifferentTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_timestamp == this->before_sample_timestamp);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TYPED_TEST(TimestampTestCompareOperators, operatorNotEqual_ComparingWithIdencticalTemporal_ShouldReturn_False)
+{ 
+  this->result= (this->sample_timestamp != this->identical_with_sample_timestamp);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TYPED_TEST(TimestampTestCompareOperators, operatorNotEqual_ComparingWithDifferentTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_timestamp != this->before_sample_timestamp);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TYPED_TEST(TimestampTestCompareOperators, operatorGreaterThan_ComparingWithIdenticalTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_timestamp > this->identical_with_sample_timestamp);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TYPED_TEST(TimestampTestCompareOperators, operatorGreaterThan_ComparingWithLaterTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_timestamp > this->after_sample_timestamp);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TYPED_TEST(TimestampTestCompareOperators, operatorGreaterThan_ComparingWithEarlierTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_timestamp > this->before_sample_timestamp);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TYPED_TEST(TimestampTestCompareOperators, operatorGreaterThanOrEqual_ComparingWithIdenticalTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_timestamp >= this->identical_with_sample_timestamp);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TYPED_TEST(TimestampTestCompareOperators, operatorGreaterThanOrEqual_ComparingWithLaterTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_timestamp >= this->after_sample_timestamp);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TYPED_TEST(TimestampTestCompareOperators, operatorGreaterThanOrEqual_ComparingWithEarlierTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_timestamp >= this->before_sample_timestamp);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TYPED_TEST(TimestampTestCompareOperators, operatorLessThan_ComparingWithIdenticalTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_timestamp < this->identical_with_sample_timestamp);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TYPED_TEST(TimestampTestCompareOperators, operatorLessThan_ComparingWithLaterTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_timestamp < this->after_sample_timestamp);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TYPED_TEST(TimestampTestCompareOperators, operatorLessThan_ComparingWithEarlierTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_timestamp < this->before_sample_timestamp);
+  
+  ASSERT_FALSE(this->result);
+}
+
+TYPED_TEST(TimestampTestCompareOperators, operatorLessThanOrEqual_ComparingWithIdenticalTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_timestamp <= this->identical_with_sample_timestamp);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TYPED_TEST(TimestampTestCompareOperators, operatorLessThanOrEqual_ComparingWithLaterTemporal_ShouldReturn_True)
+{
+  this->result= (this->sample_timestamp <= this->after_sample_timestamp);
+  
+  ASSERT_TRUE(this->result);
+}
+
+TYPED_TEST(TimestampTestCompareOperators, operatorLessThanOrEqual_ComparingWithEarlierTemporal_ShouldReturn_False)
+{
+  this->result= (this->sample_timestamp <= this->before_sample_timestamp);
+  
+  ASSERT_FALSE(this->result);
+}
+
+class TimestampTest : public ::testing::Test
+{
+  protected:
+    Timestamp timestamp;
+    bool result;
+};
+
+TEST_F(TimestampTest, is_valid_minOfTimestampRange_shouldReturn_True)
+{
+  uint32_t year= 1970, month= 1, day= 1, hour= 0, minute= 0, second= 0;
+  TemporalGenerator::TimestampGen::make_timestamp(&timestamp, year, month, day, hour, minute, second);
+
+  result= timestamp.is_valid();
+
+  ASSERT_TRUE(result);
+}
+
+TEST_F(TimestampTest, is_valid_maxOfTimestampRange_shouldReturn_True)
+{
+  uint32_t year= 2038, month= 1, day= 19, hour= 3, minute= 14, second= 7;
+  TemporalGenerator::TimestampGen::make_timestamp(&timestamp, year, month, day, hour, minute, second);
+  
+  result= timestamp.is_valid();
+  
+  ASSERT_TRUE(result);
+}
+
+TEST_F(TimestampTest, is_valid_oneSecondBeforeTimestampMinOfRange_shouldReturn_False)
+{
+  uint32_t year= 1969, month= 12, day= 31, hour= 23, minute= 59, second= 59;
+  TemporalGenerator::TimestampGen::make_timestamp(&timestamp, year, month, day, hour, minute, second);
+  
+  result= timestamp.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(TimestampTest, is_valid_oneSecondAfterTimestampMaxOfRange_shouldReturn_False)
+{
+  uint32_t year= 2038, month= 1, day= 19, hour= 3, minute= 14, second= 8;
+  TemporalGenerator::TimestampGen::make_timestamp(&timestamp, year, month, day, hour, minute, second);
+  
+  result= timestamp.is_valid();
+  
+  ASSERT_FALSE(result);
+}
+
+TEST_F(TimestampTest, is_valid_InsideOfTimestampRange_shouldReturn_True)
+{
+  uint32_t year= 1980, month= 11, day= 1, hour= 5, minute= 8, second= 5;
+  TemporalGenerator::TimestampGen::make_timestamp(&timestamp, year, month, day, hour, minute, second);
+  
+  result= timestamp.is_valid();
+  
+  ASSERT_TRUE(result);
+}
+
+TEST_F(TimestampTest, to_time_t)
+{
+  time_t time;
+  TemporalGenerator::TimestampGen::make_timestamp(&timestamp, 2009, 6, 3, 4, 59, 1);
+  
+  timestamp.to_time_t(&time);
+  
+  ASSERT_EQ(1244005141, time);
+}
+
+TEST_F(TimestampTest, outputStreamOperator_shouldWrite_hyphenSeperatedDateElements_and_colonSeperatedTimeElements)
+{
+  std::ostringstream output;
+  std::string expected= "2010-05-01 08:07:06";
+  std::string returned;
+  TemporalGenerator::TimestampGen::make_timestamp(&timestamp, 2010, 5, 1, 8, 7, 6);
+  
+  output << timestamp;
+  returned= output.str();
+  
+  ASSERT_EQ(expected, returned);
+}

